=== added file 'ACKNOWLEDGEMENTS'
--- ACKNOWLEDGEMENTS	1970-01-01 00:00:00 +0000
+++ ACKNOWLEDGEMENTS	2010-05-16 09:33:58 +0000
@@ -0,0 +1,2 @@
+Enrico's work in versions 0.31 to 0.34 has been sponsored by the Fuss Project:
+http://www.fuss.bz.it/

=== added directory 'aliases'
=== added file 'aliases/popular-apps'
--- aliases/popular-apps	1970-01-01 00:00:00 +0000
+++ aliases/popular-apps	2010-05-16 09:33:58 +0000
@@ -0,0 +1,7 @@
+# Aliases expanding names of popular applications
+
+excel		XToffice::spreadsheet
+powerpoint	XToffice::presentation
+photoshop	XTworks-with::image:raster
+coreldraw	XTworks-with::image:vector
+autocad		XTworks-with::3dmodel

=== added directory 'axi'
=== modified file 'axi-cache'
--- axi-cache	2010-04-11 09:21:41 +0000
+++ axi-cache	2010-05-16 09:33:58 +0000
@@ -1,4 +1,5 @@
 #!/usr/bin/python
+# coding: utf-8
 
 #
 # axi-cache - Query apt-xapian-index database
@@ -28,13 +29,11 @@
 from cStringIO import StringIO
 import sys
 import os, os.path
+import axi
 
-VERSION="0.29"
+VERSION="0.35"
 
 # Setup configuration
-XAPIANDBPATH = os.environ.get("AXI_DB_PATH", "/var/lib/apt-xapian-index")
-XAPIANDB = XAPIANDBPATH + "/index"
-XAPIANDBVALUES = XAPIANDBPATH + "/values"
 DEBTAGS_VOCABULARY = "/var/lib/debtags/vocabulary"
 
 #XDG_CONFIG_HOME = os.environ.get("XDG_CONFIG_HOME", os.expanduser("~/.config"))
@@ -47,8 +46,10 @@
     import math
     import xapian
     import apt
-    from debian import deb822
-
+    try:
+        from debian import deb822
+    except ImportError:
+        from debian_bundle import deb822
     helponly = False
 except ImportError, e:
     print >>sys.stderr, "%s: only help functions are implemented, for the sake of help2man" % str(e)
@@ -67,42 +68,6 @@
         def update(self,percent):
             pass
 
-    def readValueDB(pathname):
-        """
-        Read the "/etc/services"-style database of value indices
-        """
-        try:
-            rmcomments = re.compile("\s*(#.*)?$")
-            splitter = re.compile("\s+")
-            values = {}
-            for idx, line in enumerate(open(pathname)):
-                # Remove comments and trailing spaces
-                line = rmcomments.sub("", line)
-                # Skip empty lines
-                if len(line) == 0: continue
-                # Split the line
-                fields = splitter.split(line)
-                if len(fields) < 2:
-                    print >>sys.stderr, "Ignoring line %s:%d: only 1 value found when I need at least the value name and number" % (pathname, idx+1)
-                    continue
-                # Parse the number
-                try:
-                    number = int(fields[1])
-                except ValueError:
-                    print >>sys.stderr, "Ignoring line %s:%d: the second column (\"%s\") must be a number" % (pathname, idx+1, fields[1])
-                    continue
-                values[fields[0]] = number
-                for alias in fields[2:]:
-                    values[alias] = number
-        except OSError, e:
-            # If we can't read the database, fallback to defaults
-            print >>sys.stderr, "Cannot read %s: %s.  Using a minimal default configuration" % (pathname, e)
-            values = dict(
-                installedsize = 1,
-                packagesize = 2
-            )
-        return values
-
     def readVocabulary():
         try:
             fin = open(DEBTAGS_VOCABULARY)
@@ -152,13 +117,13 @@
 
         def __init__(self):
             # Access the Xapian index
-            self.db = xapian.Database(XAPIANDB)
+            self.db = xapian.Database(axi.XAPIANINDEX)
 
             self.stem = xapian.Stem("english")
 
             # Build query parser
             self.qp = xapian.QueryParser()
-            self.qp.set_default_op(xapian.Query.OP_OR)
+            self.qp.set_default_op(xapian.Query.OP_AND)
             self.qp.set_database(self.db)
             self.qp.set_stemmer(self.stem)
             self.qp.set_stemming_strategy(xapian.QueryParser.STEM_SOME)
@@ -245,26 +210,30 @@
                     xapian.QueryParser.FLAG_BOOLEAN_ANY_CASE |
                     xapian.QueryParser.FLAG_WILDCARD |
                     xapian.QueryParser.FLAG_PURE_NOT |
-                    xapian.QueryParser.FLAG_SPELLING_CORRECTION)
+                    xapian.QueryParser.FLAG_SPELLING_CORRECTION |
+                    xapian.QueryParser.FLAG_AUTO_SYNONYMS)
 
             secondary = self.get_cache_last("secondary query", None)
-            if secondary is not None:
+            if secondary:
                 secondary = self.qp.parse_query(secondary,
                     xapian.QueryParser.FLAG_BOOLEAN |
                     xapian.QueryParser.FLAG_LOVEHATE |
                     xapian.QueryParser.FLAG_BOOLEAN_ANY_CASE |
                     xapian.QueryParser.FLAG_WILDCARD |
                     xapian.QueryParser.FLAG_PURE_NOT |
-                    xapian.QueryParser.FLAG_SPELLING_CORRECTION)
+                    xapian.QueryParser.FLAG_SPELLING_CORRECTION |
+                    xapian.QueryParser.FLAG_AUTO_SYNONYMS)
                 self.query = xapian.Query(xapian.Query.OP_AND, self.query, secondary)
 
+            # print "Query:", self.query
+
             # Build the enquire with the query
             self.enquire = xapian.Enquire(self.db)
             self.enquire.set_query(self.query)
 
             sort = self.get_cache_last("sort")
             if sort is not None:
-                values = readValueDB(XAPIANDBVALUES)
+                values, descs = axi.readValueDB()
 
                 # If we don't sort by relevance, we need to specify a cutoff in order to
                 # remove poor results from the output
@@ -331,6 +300,8 @@
             self.cache.remove_option("last", key)
 
 class Cmdline(object):
+    BOOLWORDS = set(["and", "or", "not"])
+
     def __init__(self):
         self.name = "axi-cache"
 
@@ -356,7 +327,7 @@
         self.parser = Parser(self, usage="usage: %prog [options] command [args]",
                         version="%prog "+ VERSION,
                         description="Query the Apt Xapian index.ENDDESC")
-        self.parser.add_option("-s", "--sort", help="sort by the given value, as listed in %s" % XAPIANDBVALUES)
+        self.parser.add_option("-s", "--sort", help="sort by the given value, as listed in %s" % axi.XAPIANDBVALUES)
         self.parser.add_option("--tags", action="store_true", help="show matching tags, rather than packages")
         self.parser.add_option("--tabcomplete", action="store", metavar="TYPE", help="suggest words for tab completion of the current command line (type is 'plain' or 'partial')")
         self.parser.add_option("--last", action="store_true", help="use 'show --last' to limit tab completion to only the packages from the last search results")
@@ -366,6 +337,18 @@
         self.opts = opts
         self.args = args
 
+    def tabcomplete_query_args(self):
+        if self.opts.tabcomplete == "partial" and self.args:
+            queryargs = self.args[:-1]
+            partial = self.args[-1]
+        else:
+            queryargs = self.args
+            partial = None
+        # Remove trailing boolean terms
+        while queryargs and queryargs[-1].lower() in self.BOOLWORDS:
+            queryargs = queryargs[:-1]
+        return queryargs, partial
+
     def do_search(self, args):
         "search [terms]: start a new search"
         self.db = DB()
@@ -382,17 +365,26 @@
 
     def complete_search(self):
         self.db = DB()
-        if self.opts.tabcomplete == "partial" and self.args:
-            if len(self.args) == 1:
-                # Simple prefix search
-                for term in self.db.db.allterms(self.args[0]):
-                    print term.term
-                for term in self.db.db.allterms("XT" + self.args[0]):
+        if self.opts.tabcomplete == "partial" and len(self.args) == 1:
+            # Simple prefix search
+            terms = set()
+            terms.update((str(term) for term in self.db.db.synonym_keys(self.args[0])))
+            terms.update((term.term for term in self.db.db.allterms(self.args[0])))
+            for term in sorted(terms):
+                print term
+            for term in self.db.db.allterms("XT" + self.args[0]):
+                print term.term[2:]
+            return 0
+        elif self.opts.tabcomplete == "plain" and not self.args:
+            # Show a preset list of tags
+            for facet in ["interface", "role", "use", "works-with"]:
+                for term in self.db.db.allterms("XT" + facet + "::"):
                     print term.term[2:]
-                return 0
-            self.db.set_query_args(self.args[:-1])
+            return 0
         else:
-            self.db.set_query_args(self.args)
+            # Context-sensitive hints
+            qargs, partial = self.tabcomplete_query_args()
+            self.db.set_query_args(qargs)
         self.db.build_query()
         self.print_completions(self.db.get_matches())
         return 0
@@ -420,10 +412,8 @@
 
     def complete_again(self):
         self.db = DB()
-        if self.opts.tabcomplete == "partial" and self.args:
-            self.db.set_query_args(self.args[:-1], secondary=True)
-        else:
-            self.db.set_query_args(self.args, secondary=True)
+        qargs, partial = self.tabcomplete_query_args()
+        self.db.set_query_args(qargs, secondary=True)
         try:
             self.db.build_query()
         except SavedStateError, e:
@@ -462,7 +452,7 @@
         return 0
 
     def do_show(self, args):
-        "show pkgname[s]: show package details"
+        "show pkgname[s]: run apt-cache show pkgname[s]"
         os.execvp("/usr/bin/apt-cache", ["apt-cache", "show"] + args)
 
     def complete_show(self):
@@ -494,19 +484,53 @@
                     print pkg
         return 0
 
+    def do_showpkg(self, args):
+        "showpkg pkgname[s]: run apt-cache showpkg pkgname[s]"
+        os.execvp("/usr/bin/apt-cache", ["apt-cache", "showpkg"] + args)
+    complete_showpkg = complete_show
+
+    def do_showsrc(self, args):
+        "showsrc pkgname[s]: run apt-cache showsrc pkgname[s]"
+        os.execvp("/usr/bin/apt-cache", ["apt-cache", "showsrc"] + args)
+    complete_showsrc = complete_show
+
+    def do_depends(self, args):
+        "depends pkgname[s]: run apt-cache depends pkgname[s]"
+        os.execvp("/usr/bin/apt-cache", ["apt-cache", "depends"] + args)
+    complete_depends = complete_show
+
+    def do_rdepends(self, args):
+        "rdepends pkgname[s]: run apt-cache rdepends pkgname[s]"
+        os.execvp("/usr/bin/apt-cache", ["apt-cache", "rdepends"] + args)
+    complete_rdepends = complete_show
+
+    def do_policy(self, args):
+        "policy pkgname[s]: run apt-cache policy pkgname[s]"
+        os.execvp("/usr/bin/apt-cache", ["apt-cache", "policy"] + args)
+    complete_policy = complete_show
+
+    def do_madison(self, args):
+        "madison pkgname[s]: run apt-cache madison pkgname[s]"
+        os.execvp("/usr/bin/apt-cache", ["apt-cache", "madison"] + args)
+    complete_madison = complete_show
+
     def format_help(self, out):
         print >>out, "Commands:"
         itemlist = []
         maxusage = 0
-        for k, v in self.__class__.__dict__.iteritems():
+        for k, v in sorted(self.__class__.__dict__.iteritems()):
             if not k.startswith("do_"): continue
             line = self.name + " " + v.__doc__
             usage, desc = line.split(": ", 1)
             if len(usage) > maxusage:
                 maxusage = len(usage)
             itemlist.append([usage, desc])
-        for usage, desc in itemlist:
-            print >>out, "  %-*.*s  %s" % (maxusage, maxusage, usage, desc)
+        print >>out, "  search commands:"
+        for usage, desc in [x for x in itemlist if "run apt-cache" not in x[1]]:
+            print >>out, "    %-*.*s  %s" % (maxusage, maxusage, usage, desc)
+        print >>out, "  apt-cache front-ends:"
+        for usage, desc in [x for x in itemlist if "run apt-cache" in x[1]]:
+            print >>out, "    %-*.*s  %s" % (maxusage, maxusage, usage, desc)
 
     def do_help(self, args):
         "help: show a summary of commands"
@@ -527,6 +551,7 @@
         else:
             prefix = None
             exclude = self.args
+        exclude = [x for x in exclude if x.lower() not in self.BOOLWORDS]
         for s in self.clean_suggestions(self.db.get_suggestions(count=10, filter=DB.BasicFilter(stemmer=self.db.stem, exclude=exclude, prefix=prefix))):
             if s.startswith("tag:"):
                 print s[4:]

=== modified file 'axi-cache.sh'
--- axi-cache.sh	2010-04-10 17:51:06 +0000
+++ axi-cache.sh	2010-04-12 18:37:53 +0000
@@ -23,7 +23,7 @@
 
     case "$prev" in
         *axi-cache*)
-            COMPREPLY=( $(compgen -W "help more search show again" -- "$cur") )
+            COMPREPLY=( $(compgen -W "help more search show again showpkg showsrc depends rdepends policy madison" -- "$cur") )
             return 0
             ;;
         --sort)
@@ -36,33 +36,27 @@
         search|again)
             if [[ "$cur" == -* ]]; then
                 COMPREPLY=( $(compgen -W "--sort --tags" -- "$cur") )
-            else
-                if [ -n "$cur" ]; then
-                    #unset COMP_WORDS[$COMP_CWORD]
-                    COMPREPLY=( $(compgen -W "$(${COMP_WORDS[@]} --tabcomplete=partial)" -- "$cur") )
-                else
-                    if [ "$prev" != "$cmd" ]; then
-                        COMPREPLY=( $(compgen -W "$(${COMP_WORDS[@]} --tabcomplete=plain)" -- "$cur") )
-                    fi
-                fi
+                return 0
             fi
             ;;
-        show)
+        show|showpkg|showsrc|depends|rdepends|policy|madison)
             if [[ "$cur" == -* ]]; then
                 COMPREPLY=( $(compgen -W "--last" -- "$cur") )
-            else
-                if [ -n "$cur" ]; then
-                    #unset COMP_WORDS[$COMP_CWORD]
-                    COMPREPLY=( $(compgen -W "$(${COMP_WORDS[@]} --tabcomplete=partial)" -- "$cur") )
-                else
-                    COMPREPLY=( $(compgen -W "$(${COMP_WORDS[@]} --tabcomplete=plain)" -- "$cur") )
-                fi
+                return 0
             fi
             ;;
         *)
+            return 0
             ;;
     esac
 
+    if [ -n "$cur" ]; then
+        #unset COMP_WORDS[$COMP_CWORD]
+        COMPREPLY=( $(compgen -W "$(${COMP_WORDS[@]} --tabcomplete=partial)" -- "$cur") )
+    else
+        COMPREPLY=( $(compgen -W "$(${COMP_WORDS[@]} --tabcomplete=plain)" -- "$cur") )
+    fi
+
     return 0
 } &&
 complete -F _axi_cache axi-cache

=== added file 'axi/__init__.py'
--- axi/__init__.py	1970-01-01 00:00:00 +0000
+++ axi/__init__.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,76 @@
+#
+# axi - apt-xapian-index python modules
+#
+# Copyright (C) 2007--2010  Enrico Zini <enrico@debian.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import os
+import os.path
+import sys
+import re
+
+# Setup configuration
+PLUGINDIR = os.environ.get("AXI_PLUGIN_DIR", "/usr/share/apt-xapian-index/plugins")
+XAPIANDBPATH = os.environ.get("AXI_DB_PATH", "/var/lib/apt-xapian-index")
+XAPIANDBSTAMP = os.path.join(XAPIANDBPATH, "update-timestamp")
+XAPIANDBLOCK = os.path.join(XAPIANDBPATH, "update-lock")
+XAPIANDBUPDATESOCK = os.path.join(XAPIANDBPATH, "update-socket")
+XAPIANDBVALUES = os.path.join(XAPIANDBPATH, "values")
+XAPIANDBDOC = os.path.join(XAPIANDBPATH, "README")
+XAPIANINDEX = os.path.join(XAPIANDBPATH, "index")
+
+# Default value database in case one cannot be read
+DEFAULT_VALUES = dict(version=0, installedsize=1, packagesize=2)
+DEFAULT_VALUE_DESCS = dict(
+        version="package version",
+        installedsize="installed size",
+        packagesize="package size"
+)
+
+def readValueDB(pathname=XAPIANDBVALUES, quiet=False):
+    """
+    Read the "/etc/services"-style database of value indices
+    """
+    try:
+        re_empty = re.compile("^\s*(?:#.*)?$")
+        re_value = re.compile("^(\S+)\s+(\d+)(?:\s*#\s*(.+))?$")
+        values = {}
+        descs = {}
+        for idx, line in enumerate(open(pathname)):
+            # Skip empty lines and comments
+            if re_empty.match(line): continue
+            # Parse teh rest
+            mo = re_value.match(line)
+            if not mo:
+                if not quiet:
+                    print >>sys.stderr, "%s:%d: line is not `name value [# description]': ignored" % (pathname, idx+1)
+                continue
+            # Parse the number
+            name = mo.group(1)
+            number = int(mo.group(2))
+            desc = mo.group(3) or ""
+
+            values[name] = number
+            descs[name] = desc
+    except (OSError, IOError), e:
+        # If we can't read the database, fallback to defaults
+        if not quiet:
+            print >>sys.stderr, "%s: %s. Falling back on a default value database" % (pathname, e)
+        values = DEFAULT_VALUES
+        descs = DEFAULT_VALUE_DESCS
+    return values, descs
+

=== added file 'axi/indexer.py'
--- axi/indexer.py	1970-01-01 00:00:00 +0000
+++ axi/indexer.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,803 @@
+# -*- coding: utf-8 -*-
+#
+# axi/indexer.py - apt-xapian-index indexer
+#
+# Copyright (C) 2007--2010  Enrico Zini <enrico@debian.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+
+import axi
+import sys
+import os
+import imp
+import socket, errno
+import fcntl
+import textwrap
+import xapian
+import shutil
+import itertools
+import time
+import re
+import urllib
+import cPickle as pickle
+
+APTLISTDIR="/var/lib/apt/lists"
+
+class Addon:
+    """
+    Indexer plugin wrapper
+    """
+    def __init__(self, fname, **kw):
+        self.filename = os.path.basename(fname)
+        self.name = os.path.splitext(self.filename)[0]
+        oldpath = sys.path
+        try:
+            sys.path.append(os.path.dirname(fname))
+            self.module = imp.load_source("axi.plugin_" + self.name, fname)
+        finally:
+            sys.path = oldpath
+        try:
+            self.obj = self.module.init(**kw)
+        except TypeError:
+            self.obj = self.module.init()
+        if self.obj:
+            self.info = self.obj.info()
+
+    def send_extra_info(self, **kw):
+        func = getattr(self.obj, "send_extra_info", None)
+        if func is not None:
+            func(**kw)
+
+class Progress:
+    """
+    Normal progress report to stdout
+    """
+    def __init__(self):
+        self.task = None
+        self.halfway = False
+        self.is_verbose = False
+    def begin(self, task):
+        self.task = task
+        print "%s..." % self.task,
+        sys.stdout.flush()
+        self.halfway = True
+    def progress(self, percent):
+        print "\r%s... %d%%" % (self.task, percent),
+        sys.stdout.flush()
+        self.halfway = True
+    def end(self):
+        print "\r%s: done.  " % self.task
+        self.halfway = False
+    def verbose(self, *args):
+        if not self.is_verbose: return
+        if self.halfway:
+            print
+        print " ".join(args)
+        self.halfway = False
+    def notice(self, *args):
+        if self.halfway:
+            print
+        print >>sys.stderr, " ".join(args)
+        self.halfway = False
+    def warning(self, *args):
+        if self.halfway:
+            print
+        print >>sys.stderr, " ".join(args)
+        self.halfway = False
+    def error(self, *args):
+        if self.halfway:
+            print
+        print >>sys.stderr, " ".join(args)
+        self.halfway = False
+
+class BatchProgress:
+    """
+    Machine readable progress report
+    """
+    def __init__(self):
+        self.task = None
+    def begin(self, task):
+        self.task = task
+        print "begin: %s\n" % self.task,
+        sys.stdout.flush()
+    def progress(self, percent):
+        print "progress: %d/100\n" % percent,
+        sys.stdout.flush()
+    def end(self):
+        print "done: %s\n" % self.task
+        sys.stdout.flush()
+    def verbose(self, *args):
+        print "verbose: %s" % (" ".join(args))
+        sys.stdout.flush()
+    def notice(self, *args):
+        print "notice: %s" % (" ".join(args))
+        sys.stdout.flush()
+    def warning(self, *args):
+        print "warning: %s" % (" ".join(args))
+        sys.stdout.flush()
+    def error(self, *args):
+        print "error: %s" % (" ".join(args))
+        sys.stdout.flush()
+
+class SilentProgress:
+    """
+    Quiet progress report
+    """
+    def begin(self, task):
+        pass
+    def progress(self, percent):
+        pass
+    def end(self):
+        pass
+    def verbose(self, *args):
+        pass
+    def notice(self, *args):
+        pass
+    def warning(self, *args):
+        print >>sys.stderr, " ".join(args)
+    def error(self, *args):
+        print >>sys.stderr, " ".join(args)
+
+class ClientProgress:
+    """
+    Client-side progress report, reporting progress from another running
+    indexer
+    """
+    def __init__(self, progress):
+        self.sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
+        self.sock.settimeout(None)
+        self.sock.connect(axi.XAPIANDBUPDATESOCK)
+        self.progress = progress
+
+    def loop(self):
+        hasBegun = False
+        while True:
+            msg = self.sock.recv(4096)
+            try:
+                args = pickle.loads(msg)
+            except EOFError:
+                progress.error("The other update has stopped")
+                return
+            action = args[0]
+            args = args[1:]
+            if action == "begin":
+                progress.begin(*args)
+                hasBegun = True
+            elif action == "progress":
+                if not hasBegun:
+                    progress.begin(args[0])
+                    hasBegun = True
+                progress.progress(*args[1:])
+            elif action == "end":
+                if not hasBegun:
+                    progress.begin(args[0])
+                    hasBegun = True
+                progress.end(*args[1:])
+            elif action == "verbose":
+                progress.verbose(*args)
+            elif action == "notice":
+                progress.notice(*args)
+            elif action == "error":
+                progress.error(*args)
+            elif action == "alldone":
+                break
+            else:
+                progress.error("unknown action '%s' from other update-apt-xapian-index.  Arguments: '%s'" % (action, ", ".join(map(repr, args))))
+
+
+class ServerSenderProgress:
+    """
+    Server endpoint for client-server progress report
+    """
+    def __init__(self, sock, task = None):
+        self.sock = sock
+        self.task = task
+    def __del__(self):
+        self._send(pickle.dumps(("alldone",)))
+    def _send(self, text):
+        try:
+            self.sock.send(text)
+        except:
+            pass
+    def begin(self, task):
+        self.task = task
+        self._send(pickle.dumps(("begin", self.task)))
+    def progress(self, percent):
+        self._send(pickle.dumps(("progress", self.task, percent)))
+    def end(self):
+        self._send(pickle.dumps(("end", self.task)))
+    def verbose(self, *args):
+        self._send(pickle.dumps(("verbose",) + args))
+    def notice(self, *args):
+        self._send(pickle.dumps(("notice",) + args))
+    def warning(self, *args):
+        self._send(pickle.dumps(("warning",) + args))
+    def error(self, *args):
+        self._send(pickle.dumps(("error",) + args))
+
+class ServerProgress:
+    """
+    Send progress report to any progress object, as well as to client indexers
+    """
+    def __init__(self, mine):
+        self.task = None
+        self.proxied = [mine]
+        self.sockfile = axi.XAPIANDBUPDATESOCK
+        try:
+            os.unlink(self.sockfile)
+        except OSError:
+            pass
+        self.sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
+        self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
+        self.sock.bind(axi.XAPIANDBUPDATESOCK)
+        self.sock.setblocking(False)
+        self.sock.listen(5)
+        # Disallowing unwanted people to mess with the file is automatic, as
+        # the socket has the ownership of the user we're using, and people
+        # can't connect to it unless they can write to it
+    def __del__(self):
+        self.sock.close()
+        os.unlink(self.sockfile)
+    def _check(self):
+        try:
+            sock = self.sock.accept()[0]
+            self.proxied.append(ServerSenderProgress(sock, self.task))
+        except socket.error, e:
+            if e.args[0] != errno.EAGAIN:
+                raise
+        pass
+    def begin(self, task):
+        self._check()
+        self.task = task
+        for x in self.proxied: x.begin(task)
+    def progress(self, percent):
+        self._check()
+        for x in self.proxied: x.progress(percent)
+    def end(self):
+        self._check()
+        for x in self.proxied: x.end()
+    def verbose(self, *args):
+        self._check()
+        for x in self.proxied: x.verbose(*args)
+    def notice(self, *args):
+        self._check()
+        for x in self.proxied: x.notice(*args)
+    def warning(self, *args):
+        self._check()
+        for x in self.proxied: x.warning(*args)
+    def error(self, *args):
+        self._check()
+        for x in self.proxied: x.error(*args)
+
+
+class ExecutionTime(object):
+    """
+    Helper that can be used in with statements to have a simple
+    measure of the timing of a particular block of code, e.g.
+    with ExecutionTime("db flush"):
+        db.flush()
+    """
+    import time
+    def __init__(self, info=""):
+        self.info = info
+    def __enter__(self):
+        self.now = time.time()
+    def __exit__(self, type, value, stack):
+        print "%s: %s" % (self.info, time.time() - self.now)
+
+class Indexer(object):
+    """
+    The indexer
+    """
+    def __init__(self, progress, quietapt=False):
+        self.progress = progress
+        self.quietapt = quietapt
+        self.verbose = getattr(progress, "is_verbose", False)
+        # Timestamp of the most recent data source
+        self.ds_timestamp = 0
+        # Apt cache instantiated on demand
+        self.apt_cache = None
+        # Languages we index
+        self.langs = set()
+
+        # Look for files like: ftp.uk.debian.org_debian_dists_sid_main_i18n_Translation-it
+        # And extract the language code at the end
+        tfile = re.compile(r"_i18n_Translation-([^-]+)$")
+        for f in os.listdir(APTLISTDIR):
+            mo = tfile.search(f)
+            if not mo: continue
+            self.langs.add(urllib.unquote(mo.group(1)))
+
+        # Create the database directory if missing
+        try:
+            # Try to create it anyway
+            os.mkdir(axi.XAPIANDBPATH)
+        except OSError, e:
+            if e.errno != errno.EEXIST:
+                # If we got an error besides path already existing, fail
+                raise
+            elif not os.path.isdir(axi.XAPIANDBPATH):
+                # If that path already exists, but is not a directory, also fail
+                raise
+
+    def _test_wrap_apt_cache(self, wrapper):
+        """
+        Wrap the apt-cache in some proxy object.
+
+        This is used to give tests some control over the apt cache results
+        """
+        if self.apt_cache is not None:
+            raise RuntimeError("the cache has already been instantiated")
+        # Instantiate the cache
+        self.aptcache()
+        # Wrap it
+        self.apt_cache = wrapper(self.apt_cache)
+
+    def aptcache(self):
+        if not self.apt_cache:
+            #import warnings
+            ## Yes, apt, thanks, I know, the api isn't stable, thank you so very much
+            ##warnings.simplefilter('ignore', FutureWarning)
+            #warnings.filterwarnings("ignore","apt API not stable yet")
+            import apt
+            #warnings.resetwarnings()
+
+            if self.quietapt:
+                class AptSilentProgress(apt.progress.text.OpProgress) :
+                    def __init__(self): 
+                        pass
+                    def done(self):
+                        pass
+                    def update(self,percent):
+                        pass
+                aptprogress = AptSilentProgress()
+            else:
+                aptprogress = None
+
+            # memonly=True: force apt to not write a pkgcache.bin
+            self.apt_cache = apt.Cache(memonly=True, progress=aptprogress)
+        return self.apt_cache
+
+    def lock(self):
+        """
+        Lock the session to prevent further updates.
+
+        @returns
+          True if the session is locked
+          False if another indexer is running
+        """
+        # Lock the session so that we prevent concurrent updates
+        lockfd = os.open(axi.XAPIANDBLOCK, os.O_RDWR | os.O_CREAT)
+        lockpyfd = os.fdopen(lockfd)
+        try:
+            fcntl.lockf(lockpyfd, fcntl.LOCK_EX | fcntl.LOCK_NB)
+            # Wrap the current progress with the server sender
+            self.progress = ServerProgress(self.progress)
+            return True
+        except IOError, e:
+            if e.errno == errno.EACCES or e.errno == errno.EAGAIN:
+                return False
+            else:
+                raise
+
+    def slave(self):
+        """
+        Attach to a running indexer and report its progress.
+
+        Return when the other indexer has finished.
+        """
+        progress.notice("Another update is already running: showing its progress.")
+        childProgress = ClientProgress(self.progress)
+        childProgress.loop()
+
+    def readPlugins(self, **kw):
+        """
+        Read the addons, in sorted order.
+
+        Pass all the keyword args to the plugin init
+        """
+        self.addons = []
+        for fname in sorted(os.listdir(axi.PLUGINDIR)):
+            # Skip non-pythons, hidden files and python sources starting with '_'
+            if fname[0] in ['.', '_'] or not fname.endswith(".py"): continue
+            fullname = os.path.join(axi.PLUGINDIR, fname)
+            if not os.path.isfile(fullname): continue
+            self.progress.verbose("Reading plugin %s." % fullname)
+            addon = Addon(fullname, **kw)
+            if addon.obj != None:
+                self.addons.append(addon)
+
+    def setupIndexing(self, force=False):
+        """
+        Setup indexing: read plugins, check timestamps...
+
+        @param force: if True, reindex also if the index is up to date
+
+        @return:
+          True if there is something to index
+          False if there is no need of indexing
+        """
+        # Read values database
+        #values = readValueDB(VALUESCONF, progress)
+
+        # Read the addons, in sorted order
+        self.readPlugins(langs=self.langs, progress=self.progress)
+
+        # Ensure that we have something to do
+        if len(self.addons) == 0:
+            self.progress.notice("No indexing plugins found in %s" % axi.PLUGINDIR)
+            return False
+
+        # Get the most recent modification timestamp of the data sources
+        self.ds_timestamp = max([x.info['timestamp'] for x in self.addons])
+
+        # Get the timestamp of the last database update
+        try:
+            if os.path.exists(axi.XAPIANDBSTAMP):
+                cur_timestamp = os.path.getmtime(axi.XAPIANDBSTAMP)
+            else:
+                cur_timestamp = 0
+        except OSError, e:
+            cur_timestamp = 0
+            self.progress.notice("Reading current timestamp failed: %s. Assuming the index has not been created yet." % e)
+
+        if self.verbose:
+            self.progress.verbose("Most recent dataset:    %s." % time.ctime(self.ds_timestamp))
+            self.progress.verbose("Most recent update for: %s." % time.ctime(cur_timestamp))
+
+        # See if we need an update
+        if self.ds_timestamp <= cur_timestamp:
+            if force:
+                self.progress.notice("The index %s is up to date, but rebuilding anyway as requested." % axi.XAPIANDBPATH)
+            else:
+                self.progress.notice("The index %s is up to date" % axi.XAPIANDBPATH)
+                return False
+
+        # Build the value database
+        self.progress.verbose("Aggregating value information.")
+        # Read existing value database to keep ids stable in a system
+        self.values, self.values_desc = axi.readValueDB(quiet=True)
+        values_seq = max(self.values.values()) + 1
+        for addon in self.addons:
+            for v in addon.info.get("values", []):
+                if v['name'] in self.values: continue
+                self.values[v['name']] = values_seq
+                values_seq += 1
+                self.values_desc[v['name']] = v['desc']
+
+        # Tell the addons to do the long initialisation bits
+        self.progress.verbose("Initializing plugins.")
+        for addon in self.addons:
+            addon.obj.init(dict(values = self.values), self.progress)
+
+        return True
+
+    def get_document_from_apt(self, pkg):
+        """
+        Get a xapian.Document for the given apt package record
+        """
+        document = xapian.Document()
+        # The document data is the package name
+        document.set_data(pkg.name)
+        # add information about the version of the package in slot 0
+        document.add_value(0, pkg.candidate.version)
+        # Index the package name with a special prefix, to be able to find this
+        # document by exact package name match
+        document.add_term("XP"+pkg.name)
+        # Have all the various plugins index their things
+        for addon in self.addons:
+            addon.obj.index(document, pkg)
+        return document
+
+    def get_document_from_deb822(self, pkg):
+        """
+        Get a xapian.Document for the given deb822 package record
+        """
+        document = xapian.Document()
+
+        # The document data is the package name
+        document.set_data(pkg["Package"])
+        # add information about the version of the package in slot 0
+        document.add_value(0, pkg["Version"])
+        # Index the package name with a special prefix, to be able to find this
+        # document by exact package name match
+        document.add_term("XP"+pkg["Package"])
+        # Have all the various plugins index their things
+        for addon in self.addons:
+            addon.obj.indexDeb822(document, pkg)
+        return document
+
+    def gen_documents_apt(self):
+        """
+        Generate Xapian documents from an apt cache
+        """
+        cache = self.aptcache()
+        count = len(cache)
+        for idx, pkg in enumerate(cache):
+            if not pkg.candidate:
+                continue
+            # Print progress
+            if idx % 200 == 0: self.progress.progress(100*idx/count)
+            yield self.get_document_from_apt(pkg)
+
+    def gen_documents_deb822(self, fname):
+        try:
+            from debian import deb822
+        except ImportError:
+            from debian_bundle import deb822
+        infd = open(fname)
+        # Get file size to compute progress
+        total = os.fstat(infd.fileno())[6]
+        for idx, pkg in enumerate(deb822.Deb822.iter_paragraphs(infd)):
+            # Print approximate progress by checking the current read position
+            # against the file size
+            if total > 0 and idx % 200 == 0:
+                cur = infd.tell()
+                self.progress.progress(100*cur/total)
+            yield self.get_document_from_deb822(pkg)
+
+    def compareCacheToDb(self, cache, db):
+        """
+        Compare the apt cache to the database and return dicts
+        of the form (pkgname, docid) for the following states:
+
+        unchanged - no new version since the last update
+        outdated - a new version since the last update
+        obsolete - no longer in the apt cache
+        """
+        unchanged = {}
+        outdated = {}
+        obsolete = {}
+        self.progress.begin("Reading Xapian index")
+        count = db.get_doccount()
+        for (idx, m) in enumerate(db.postlist("")):
+            if idx % 5000 == 0: self.progress.progress(100*idx/count)
+            doc = db.get_document(m.docid)
+            pkg = doc.get_data()
+            # this will return '' if there is no value 0, which is fine because it
+            # will fail the comparison with the candidate version causing a reindex
+            dbver = doc.get_value(0)
+            # check if the package no longer exists
+            if not cache.has_key(pkg) or not cache[pkg].candidate:
+                obsolete[pkg] = m.docid
+            # check if we have a new version, we do not have to delete
+            # the record,
+            elif cache[pkg].candidate.version != dbver:
+                outdated[pkg] = m.docid
+            # its a valid package and we know about it already
+            else:
+                unchanged[pkg] = m.docid
+        self.progress.end()
+        return unchanged, outdated, obsolete
+
+    def updateIndex(self, pathname):
+        """
+        Update the index
+        """
+        db = xapian.WritableDatabase(pathname, xapian.DB_CREATE_OR_OPEN)
+        cache = self.aptcache()
+        count = len(cache)
+
+        unchanged, outdated, obsolete = self.compareCacheToDb(cache, db)
+        self.progress.verbose("Unchanged versions: %s, oudated version: %s, "
+                         "obsolete versions: %s" % (len(unchanged),
+                                                    len(outdated),
+                                                    len(obsolete)))
+
+        self.progress.begin("Updating Xapian index")
+        for a in self.addons: a.send_extra_info(db=db, aptcache=cache)
+        for idx, pkg in enumerate(cache):
+            if idx % 1000 == 0: self.progress.progress(100*idx/count)
+            if not pkg.candidate:
+                continue
+            if pkg.name in unchanged:
+                continue
+            elif pkg.name in outdated:
+                # update the existing
+                db.replace_document(outdated[pkg.name], self.get_document_from_apt(pkg))
+            else:
+                # add the new ones
+                db.add_document(self.get_document_from_apt(pkg))
+
+        # and remove the obsoletes
+        for docid in obsolete.values():
+            db.delete_document(docid)
+
+        # finished
+        db.flush()
+        self.progress.end()
+
+    def incrementalUpdate(self):
+        if not os.path.exists(axi.XAPIANINDEX):
+            self.progress.notice("No Xapian index built yet: falling back to full rebuild")
+            return self.rebuild()
+
+        dbkind, dbpath = open(axi.XAPIANINDEX).readline().split()
+        self.updateIndex(dbpath)
+
+        # Update the index timestamp
+        if not os.path.exists(axi.XAPIANDBSTAMP):
+            open(axi.XAPIANDBSTAMP, "w").close()
+        os.utime(axi.XAPIANDBSTAMP, (self.ds_timestamp, self.ds_timestamp))
+
+    def buildIndex(self, pathname, documents, addoninfo={}):
+        """
+        Create a new Xapian index with the content provided by the addons
+        """
+        self.progress.begin("Rebuilding Xapian index")
+
+        # Create a new Xapian index
+        db = xapian.WritableDatabase(pathname, xapian.DB_CREATE_OR_OVERWRITE)
+        # It seems to be faster without transactions, at the moment
+        #db.begin_transaction(False)
+
+        for a in self.addons: a.send_extra_info(db=db)
+
+        # Add all generated documents to the index
+        for doc in documents:
+            db.add_document(doc)
+
+        #db.commit_transaction();
+        db.flush()
+        self.progress.end()
+
+    def rebuild(self, pkgfile=None):
+        # Create a new Xapian index with the content provided by the addons
+        # Xapian takes care of preventing concurrent updates and removing the old
+        # database if it's left over by a previous crashed update
+
+        # Generate a new index name
+        for idx in itertools.count(1):
+            tmpidxfname = "index.%d" % idx
+            dbdir = axi.XAPIANDBPATH + "/" + tmpidxfname
+            if not os.path.exists(dbdir): break;
+
+        if pkgfile:
+            generator = self.gen_documents_deb822(pkgfile)
+        else:
+            for a in self.addons: a.send_extra_info(aptcache=self.aptcache())
+            generator = self.gen_documents_apt()
+        self.buildIndex(dbdir, generator)
+
+        # Update the 'index' symlink to point at the new index
+        self.progress.verbose("Installing the new index.")
+
+        #os.symlink(tmpidxfname, axi.XAPIANDBPATH + "/index.tmp")
+        out = open(axi.XAPIANINDEX + ".tmp", "w")
+        print >>out, "auto", os.path.join(os.path.abspath(axi.XAPIANDBPATH), tmpidxfname)
+        out.close()
+        os.rename(axi.XAPIANINDEX + ".tmp", axi.XAPIANINDEX)
+
+        # Remove all other index.* directories that are not the newly created one
+        for file in os.listdir(axi.XAPIANDBPATH):
+            if not file.startswith("index."): continue
+            # Only delete directories
+            if not os.path.isdir(axi.XAPIANDBPATH + "/" + file): continue
+            # Don't delete what we just created
+            if file == tmpidxfname: continue
+            fullpath = axi.XAPIANDBPATH + "/" + file
+            self.progress.verbose("Removing old index %s." % fullpath)
+            shutil.rmtree(fullpath)
+
+        # Commit the changes and update the last update timestamp
+        if not os.path.exists(axi.XAPIANDBSTAMP):
+            open(axi.XAPIANDBSTAMP, "w").close()
+        os.utime(axi.XAPIANDBSTAMP, (self.ds_timestamp, self.ds_timestamp))
+
+        self.writeValues()
+        self.writeDoc()
+
+    def writeValues(self, pathname=axi.XAPIANDBVALUES):
+        """
+        Write the value information on the given file
+        """
+        self.progress.verbose("Writing value information to %s." % pathname)
+        out = open(pathname+".tmp", "w")
+
+        print >>out, textwrap.dedent("""
+        # This file contains the mapping between names of numeric values indexed in the
+        # APT Xapian index and their index
+        #
+        # Xapian allows to index numeric values as well as keywords and to use them for
+        # all sorts of useful querying tricks.  However, every numeric value needs to
+        # have a unique index, and this configuration file is needed to record which
+        # indices are allocated and to provide a mnemonic name for them.
+        #
+        # The format is exactly like /etc/services with name, number and optional
+        # aliases, with the difference that the second column does not use the
+        # "/protocol" part, which would be meaningless here.
+        """).lstrip()
+
+        for name, idx in sorted(self.values.iteritems(), key=lambda x: x[1]):
+            desc = self.values_desc[name]
+            print >>out, "%s\t%d\t# %s" % (name, idx, desc)
+
+        out.close()
+        # Atomic update of the documentation
+        os.rename(pathname+".tmp", pathname)
+
+    def writeDoc(self, pathname=axi.XAPIANDBDOC):
+        """
+        Write the documentation in the given file
+        """
+        self.progress.verbose("Writing documentation to %s." % pathname)
+        # Collect the documentation
+        docinfo = []
+        for addon in self.addons:
+            try:
+                doc = addon.obj.doc()
+                if doc != None:
+                    docinfo.append(dict(
+                        name = doc['name'],
+                        shortDesc = doc['shortDesc'],
+                        fullDoc = doc['fullDoc']))
+            except:
+                # If a plugin has problem returning documentation, don't worry about it
+                self.progress.notice("Skipping documentation for plugin", addon.filename)
+
+        # Write the documentation in pathname
+        out = open(pathname+".tmp", "w")
+        print >>out, textwrap.dedent("""
+        ===============
+        Database layout
+        ===============
+
+        This Xapian database indexes Debian package information.  To query the
+        database, open it as ``%s/index``.
+
+        Data are indexed either as terms or as values.  Words found in package
+        descriptions are indexed lowercase, and all other kinds of terms have an
+        uppercase prefix as documented below.
+
+        Numbers are indexed as Xapian numeric values.  A list of the meaning of the
+        numeric values is found in ``%s``.
+
+        The data sources used for indexing are:
+        """).lstrip() % (axi.XAPIANDBPATH, axi.XAPIANDBVALUES)
+
+        for d in docinfo:
+            print >>out, " * %s: %s" % (d['name'], d['shortDesc'])
+
+        print >>out, textwrap.dedent("""
+        This Xapian index follows the conventions for term prefixes described in
+        ``/usr/share/doc/xapian-omega/termprefixes.txt.gz``.
+
+        Extra Debian data sources can define more extended prefixes (starting with
+        ``X``): their meaning is documented below together with the rest of the data
+        source documentation.
+
+        At the very least, at least the package name (with the ``XP`` prefix) will
+        be present in every document in the database.  This allows to quickly
+        lookup a Xapian document by package name.
+
+        The user data associated to a Xapian document is the package name.
+
+
+        -------------------
+        Active data sources
+        -------------------
+
+        """)
+        for d in docinfo:
+            print >>out, d['name']
+            print >>out, '='*len(d['name'])
+            print >>out, textwrap.dedent(d['fullDoc'])
+            print >>out
+
+        out.close()
+        # Atomic update of the documentation
+        os.rename(pathname+".tmp", pathname)
+

=== modified file 'debian/changelog'
--- debian/changelog	2010-04-11 09:21:41 +0000
+++ debian/changelog	2010-05-16 09:33:58 +0000
@@ -1,3 +1,77 @@
+apt-xapian-index (0.35) unstable; urgency=low
+
+  * Tolerate (and if --verbose, report) .desktop file with invalid popcon
+    fields
+  * Added missing import. Closes: #581736
+  * Run update-python-modules -p before updating the index in postinst.
+    Closes: #581811
+
+ -- Enrico Zini <enrico@debian.org>  Sun, 16 May 2010 09:33:58 +0100
+
+apt-xapian-index (0.34) unstable; urgency=low
+
+  * Added aliases plugin, to feed synonims to the index
+  * Tolerate older versions of python-debian
+  * Give a nicer error message if run with not enough permissions
+  * Added acknowledgements file mentioning sponsorship by the Fuss project
+
+ -- Enrico Zini <enrico@debian.org>  Thu, 13 May 2010 14:19:43 +0100
+
+apt-xapian-index (0.33) unstable; urgency=low
+
+  * Added missing import, fixing indexing of multilanguage descriptions
+
+ -- Enrico Zini <enrico@debian.org>  Wed, 12 May 2010 22:31:31 +0100
+
+apt-xapian-index (0.32) unstable; urgency=low
+
+  * Tolerate plugins' init functions that do not expect any arguments
+
+ -- Enrico Zini <enrico@debian.org>  Wed, 12 May 2010 21:42:43 +0100
+
+apt-xapian-index (0.31) unstable; urgency=low
+
+  [ David Paleino ]
+  * debian/rules: set COLUMNS envvar when calling help2man (Closes: #577525)
+  * debian/cron.weekly:
+    - pass --update to update-apt-xapian-index, try to be less
+      invasive during background runs (LP: #363695)
+    - don't run the indexer when on battery power
+  * axi-cache, update-xapian-index: update version number
+
+  [ Axel Rutz ]
+  * debian/cron.weekly:
+    - inserted missing space in 'ionice -c 3'
+    - give the indexer maximum niceness (LP: #363695)
+
+  [ Enrico Zini ]
+  * Switch to debhelper7 and distutils
+  * Reorganised code in modules
+  * Added a test suite
+  * Added indexer for app-install .desktop file information
+
+ -- Enrico Zini <enrico@debian.org>  Wed, 12 May 2010 21:42:36 +0100
+
+apt-xapian-index (0.30) unstable; urgency=low
+
+  [ Enrico Zini ]
+  * axi-cache: fix behaviour of again with no parameters
+  * axi-cache: AND terms by default instead of OR
+  * axi-cache: remove AND, OR and NOT from partial expressions when providing
+    tab completion candidates
+  * axi-cache: suggest tags from a preset list of facets when completing
+    "axi-cache search "
+  * axi-cache: when completing "axi-cache again " suggest context-sensitive
+    terms from the previous "search" query
+  * axi-cache: implemented showpkg
+  * axi-cache: implemented showsrc
+  * axi-cache: implemented depends, rdepends, policy, madison 
+
+  [ David Paleino ]
+  * axi-cache.sh: move common "else" clause out of the last case..esac
+
+ -- David Paleino <dapal@debian.org>  Mon, 12 Apr 2010 18:37:53 +0200
+
 apt-xapian-index (0.29) unstable; urgency=low
 
   * axi-cache: don't die horribly if a package exists in a-x-i but not in apt

=== modified file 'debian/control'
--- debian/control	2010-04-10 17:51:06 +0000
+++ debian/control	2010-05-16 09:33:58 +0000
@@ -3,17 +3,19 @@
 Priority: optional
 Maintainer: Enrico Zini <enrico@debian.org>
 Uploaders: David Paleino <dapal@debian.org>
-Build-Depends: debhelper (>= 5.0.0), cdbs
-Build-Depends-Indep: help2man, python
- , bash-completion (>= 1:1.0-1~)
+Build-Depends: debhelper (>= 7.0.50~)
+Build-Depends-Indep: help2man, python, python-support,
+ bash-completion (>= 1:1.0-1~)
 Standards-Version: 3.8.4.0
 Vcs-Git: git://git.debian.org/git/collab-maint/apt-xapian-index.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/apt-xapian-index.git
 Homepage: http://www.enricozini.org/sw/apt-xapian-index/
+XS-Python-Version: >=2.4
 
 Package: apt-xapian-index
 Architecture: all
-Depends: python, python-xapian (>= 1.0.2), python-apt (>= 0.7.93.2), python-debian (>= 0.1.15), ${misc:Depends}
+Depends: python, python-xapian (>= 1.0.2), python-apt (>= 0.7.93.2), python-debian (>= 0.1.14), ${python:Depends}, ${misc:Depends}
+Suggests: app-install-data, python-xdg
 Description: maintenance tools for a Xapian index of Debian packages
  This package provides update-apt-xapian-index, a tool to maintan a Xapian
  index of Debian package information in /var/lib/apt-xapian-index.

=== modified file 'debian/cron.weekly'
--- debian/cron.weekly	2010-02-14 18:51:21 +0000
+++ debian/cron.weekly	2010-05-16 09:33:58 +0000
@@ -3,13 +3,25 @@
 CMD=/usr/sbin/update-apt-xapian-index
 IONICE=/usr/bin/ionice
 
+# Check if we're on battery
+if which on_ac_power >/dev/null 2>&1; then
+    on_ac_power >/dev/null 2>&1
+    ON_BATTERY=$?
+
+    # Here we use "-eq 1" instead of "-ne 0" because
+    # on_ac_power could also return 255, which means
+    # it can't tell whether we are on AC or not. In
+    # that case, run update-a-x-i nevertheless.
+    [ "$ON_BATTERY" -eq 1 ] && exit 0
+fi
+
 # Rebuild the index
 if [ -x $CMD ]
 then
 	if [ -x $IONICE ]
 	then
-		nice $IONICE -c3 $CMD --quiet
+		nice -n 19 $IONICE -c 3 $CMD --update --quiet
 	else
-		nice $CMD --quiet
+		nice -n 19 $CMD --update --quiet
 	fi
 fi

=== modified file 'debian/dirs'
--- debian/dirs	2010-04-10 17:51:06 +0000
+++ debian/dirs	2010-05-16 09:33:58 +0000
@@ -2,7 +2,8 @@
 usr/sbin
 usr/share/doc
 usr/share/apt-xapian-index
+usr/share/apt-xapian-index/aliases
 usr/share/apt-xapian-index/plugins
 etc/dbus-1/system.d
 usr/share/dbus-1/system-services
-usr/share/polkit-1/actions
\ No newline at end of file
+usr/share/polkit-1/actions

=== modified file 'debian/docs'
--- debian/docs	2007-10-22 15:34:38 +0000
+++ debian/docs	2010-05-16 09:33:58 +0000
@@ -1,1 +1,2 @@
 README
+ACKNOWLEDGEMENTS

=== modified file 'debian/postinst'
--- debian/postinst	2009-07-07 16:28:48 +0000
+++ debian/postinst	2010-05-16 09:33:58 +0000
@@ -11,6 +11,8 @@
 		if [ ! -x /usr/sbin/policy-rc.d ] || /usr/sbin/policy-rc.d apt-xapian-index start
 		then
 			echo "apt-xapian-index: Building new index in background..."
+			# Ensure that we can use our module. See #537376
+			update-python-modules -p
 			nice /usr/sbin/update-apt-xapian-index --quiet &
 		fi
 	fi

=== modified file 'debian/rules'
--- debian/rules	2010-04-10 17:51:06 +0000
+++ debian/rules	2010-05-16 09:33:58 +0000
@@ -1,32 +1,37 @@
 #!/usr/bin/make -f
 
-include /usr/share/cdbs/1/rules/debhelper.mk
-
 VERSION=$(shell debian/vercheck)
 RELEASE_PACKAGE=apt-xapian-index
-
-build/apt-xapian-index::
+PFX=$(CURDIR)/debian/apt-xapian-index
+
+%:
+	dh  $@
+
+override_dh_auto_build:
+	dh_auto_build
 	help2man --section=8 --no-info ./update-apt-xapian-index > update-apt-xapian-index.8
-	help2man --section=1 --no-info ./axi-cache > axi-cache.1
+	COLUMNS=200 help2man --section=1 --no-info ./axi-cache > axi-cache.1
 
-install/apt-xapian-index::
-	# Install the executable
-	install -o root -g root -m 755 update-apt-xapian-index debian/$(cdbs_curpkg)/usr/sbin
-	install -o root -g root -m 755 axi-cache debian/$(cdbs_curpkg)/usr/bin
+override_dh_auto_install:
+	dh_auto_install
+	mv $(PFX)/usr/bin/update-apt-xapian-index \
+	   $(PFX)/usr/sbin/update-apt-xapian-index
 	# Install the plugins
-	install -o root -g root -m 755 -d debian/$(cdbs_curpkg)/usr/share/apt-xapian-index/plugins
-	install -o root -g root -m 644 plugins/*.py debian/$(cdbs_curpkg)/usr/share/apt-xapian-index/plugins/
+	install -o root -g root -m 755 -d $(PFX)/usr/share/apt-xapian-index/plugins
+	install -o root -g root -m 644 aliases/* $(PFX)/usr/share/apt-xapian-index/aliases/
+	install -o root -g root -m 644 plugins/*.py $(PFX)/usr/share/apt-xapian-index/plugins/
 	# Install the dbus stuff
-	install -o root -g root -m 755 update-apt-xapian-index-dbus debian/$(cdbs_curpkg)/usr/share/apt-xapian-index
-	install -o root -g root -m 644 data/org.debian.AptXapianIndex.conf debian/$(cdbs_curpkg)/etc/dbus-1/system.d
-	install -o root -g root -m 644 data/org.debian.AptXapianIndex.service debian/$(cdbs_curpkg)/usr/share/dbus-1/system-services/org.debian.AptXapianIndex.service
-	install -o root -g root -m 644 data/org.debian.aptxapianindex.policy debian/$(cdbs_curpkg)/usr/share/polkit-1/actions
+	install -o root -g root -m 755 update-apt-xapian-index-dbus $(PFX)/usr/share/apt-xapian-index
+	install -o root -g root -m 644 data/org.debian.AptXapianIndex.conf $(PFX)/etc/dbus-1/system.d
+	install -o root -g root -m 644 data/org.debian.AptXapianIndex.service $(PFX)/usr/share/dbus-1/system-services/org.debian.AptXapianIndex.service
+	install -o root -g root -m 644 data/org.debian.aptxapianindex.policy $(PFX)/usr/share/polkit-1/actions
 	# Install bash completion
 	dh_bash-completion
 
-clean::
+override_dh_auto_clean:
+	dh_auto_clean
 	find . -name "*.pyc" -delete
-	rm -f update-apt-xapian-index.8 axi-cache.8
+	rm -f update-apt-xapian-index.8 axi-cache.1
 
 vercheck:
 	debian/vercheck > /dev/null

=== added file 'plugins/aliases.py'
--- plugins/aliases.py	1970-01-01 00:00:00 +0000
+++ plugins/aliases.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,123 @@
+import xapian
+import os, os.path
+
+AXI_ALIASES = os.environ.get("AXI_ALIASES", "/etc/apt-xapian-index/aliases/:/usr/share/apt-xapian-index/aliases/")
+
+def read_db(progress=None):
+    aliases = []
+    maxts = 0
+    for d in AXI_ALIASES.split(":"):
+        if not os.path.isdir(d): continue
+        for f in os.listdir(d):
+            if f[0] == '.': continue
+            fname = os.path.join(d, f)
+            ts = os.path.getmtime(fname)
+            if ts > maxts:
+                maxts = ts
+            if progress: progress.verbose("Reading aliases from %s..." % fname)
+            for line in open(fname):
+                line = line.split()
+                # Skip comments and empty lines
+                if not line or line[0][0] == '#': continue
+                aliases.append(line)
+    return maxts, aliases
+
+class Aliases:
+    def __init__(self, maxts, db):
+        self.maxts = maxts
+        self.db = db
+
+    def info(self):
+        """
+        Return general information about the plugin.
+
+        The information returned is a dict with various keywords:
+
+         timestamp (required)
+           the last modified timestamp of this data source.  This will be used
+           to see if we need to update the database or not.  A timestamp of 0
+           means that this data source is either missing or always up to date.
+         values (optional)
+           an array of dicts { name: name, desc: description }, one for every
+           numeric value indexed by this data source.
+
+        Note that this method can be called before init.  The idea is that, if
+        the timestamp shows that this plugin is currently not needed, then the
+        long initialisation can just be skipped.
+        """
+        return dict(timestamp = self.maxts)
+
+    def init(self, info, progress):
+        """
+        If needed, perform long initialisation tasks here.
+
+        info is a dictionary with useful information.  Currently it contains
+        the following values:
+
+          "values": a dict mapping index mnemonics to index numbers
+
+        The progress indicator can be used to report progress.
+        """
+        pass
+
+    def send_extra_info(self, db=None, **kw):
+        """
+        Receive extra parameters from the indexer.
+
+        This may be called more than once, but after init().
+
+        We are using this to get the database instance
+        """
+        if db is not None:
+            for row in self.db:
+                for a in row[1:]:
+                    db.add_synonym(row[0], a)
+
+    def doc(self):
+        """
+        Return documentation information for this data source.
+
+        The documentation information is a dictionary with these keys:
+          name: the name for this data source
+          shortDesc: a short description
+          fullDoc: the full description as a chapter in ReST format
+        """
+        return dict(
+            name = "Package aliases",
+            shortDesc = "aliases for well known programs",
+            fullDoc = """
+            The Aliases data source does not change documents in the index, but
+            adds synonims to the database. Synonims allow to obtain good
+            results while looking for well-know software names, even if such
+            software does not exist in Debian.
+            """
+        )
+
+    def index(self, document, pkg):
+        """
+        Update the document with the information from this data source.
+
+        document  is the document to update
+        pkg       is the python-apt Package object for this package
+        """
+        pass
+
+    def indexDeb822(self, document, pkg):
+        """
+        Update the document with the information from this data source.
+
+        This is alternative to index, and it is used when indexing with package
+        data taken from a custom Packages file.
+
+        document  is the document to update
+        pkg       is the Deb822 object for this package
+        """
+        pass
+
+def init(progress=None, **kw):
+    """
+    Create and return the plugin object.
+    """
+    maxts, db = read_db(progress)
+    if not db: return None
+    return Aliases(maxts, db)

=== added file 'plugins/app-install.py'
--- plugins/app-install.py	1970-01-01 00:00:00 +0000
+++ plugins/app-install.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,207 @@
+try:
+    from xdg.DesktopEntry import DesktopEntry
+    from xdg import Locale
+    HAS_XDG=True
+except ImportError, e:
+    HAS_XDG=False
+    import sys
+    print >>sys.stderr, e
+
+import axi.indexer
+import apt
+import xapian
+import os, os.path
+
+APPINSTALLDIR="/usr/share/app-install/desktop/"
+
+class Indexer:
+    def __init__(self, lang, val_popcon, progress=None):
+        self.val_popcon = val_popcon
+        self.progress = progress
+        if lang is None:
+            lang = "en"
+        self.lang = lang
+        self.xlang = lang.split("_")[0]
+        self.xdglangs = Locale.expand_languages(lang)
+        self.indexer = xapian.TermGenerator()
+        # Get a stemmer for this language, if available
+        try:
+            self.stemmer = xapian.Stem(self.xlang)
+            self.indexer.set_stemmer(self.stemmer)
+        except xapian.InvalidArgumentError:
+            pass
+
+    def index(self, document, fname, entry):
+        # Index a single term "XD", marking that the package contains .desktop
+        # files
+        document.add_term("XD")
+
+        # Index the name of the .desktop file, with prefix XDF
+        document.add_term("XDF" + fname)
+
+        # Index keywords retrieved in this indexer's language
+        self.indexer.set_document(document)
+        oldlangs = Locale.langs
+        try:
+            Locale.langs = self.xdglangs
+            self.indexer.index_text_without_positions(entry.getName())
+            self.indexer.index_text_without_positions(entry.getGenericName())
+            self.indexer.index_text_without_positions(entry.getComment())
+        finally:
+            Locale.langs = oldlangs
+
+        # Index .desktop categories, with prefix XDT
+        for cat in entry.getCategories():
+            document.add_term("XDT"+cat)
+
+        # Add an "app-popcon" value with popcon rank
+        try:
+            popcon = int(entry.get("X-AppInstall-Popcon"))
+        except ValueError, e:
+            if self.progress:
+                self.progress.verbose("%s: parsing X-AppInstall-Popcon: %s" % (fname, str(e)))
+            popcon = -1
+        if self.val_popcon != -1:
+            document.add_value(self.val_popcon, xapian.sortable_serialise(popcon));
+
+
+class AppInstall(object):
+    def __init__(self, langs, progress):
+        self.langs = langs
+        self.progress = progress
+
+    def info(self):
+        """
+        Return general information about the plugin.
+
+        The information returned is a dict with various keywords:
+         
+         timestamp (required)
+           the last modified timestamp of this data source.  This will be used
+           to see if we need to update the database or not.  A timestamp of 0
+           means that this data source is either missing or always up to date.
+         values (optional)
+           an array of dicts { name: name, desc: description }, one for every
+           numeric value indexed by this data source.
+
+        Note that this method can be called before init.  The idea is that, if
+        the timestamp shows that this plugin is currently not needed, then the
+        long initialisation can just be skipped.
+        """
+        maxts = 0
+        for f in os.listdir(APPINSTALLDIR):
+            if f[0] == '.' or not f.endswith(".desktop"): continue
+            ts = os.path.getmtime(os.path.join(APPINSTALLDIR, f))
+            if ts > maxts: maxts = ts
+        return dict(
+                timestamp = maxts,
+                values = [
+                    dict(name = "app-popcon", desc = "app-install .desktop popcon rank"),
+                ])
+
+    def init(self, info, progress):
+        """
+        If needed, perform long initialisation tasks here.
+
+        info is a dictionary with useful information.  Currently it contains
+        the following values:
+
+          "values": a dict mapping index mnemonics to index numbers
+
+        The progress indicator can be used to report progress.
+        """
+
+        # Read the value indexes we will use
+        values = info['values']
+        self.val_popcon = values.get("app-popcon", -1)
+
+        self.indexers = [Indexer(lang, self.val_popcon, progress) for lang in [None] + list(self.langs)]
+        self.entries = {}
+
+        progress.begin("Reading .desktop files from %s" % APPINSTALLDIR)
+        for f in os.listdir(APPINSTALLDIR):
+            if f[0] == '.' or not f.endswith(".desktop"): continue
+            entry = DesktopEntry(os.path.join(APPINSTALLDIR, f))
+            pkg = entry.get("X-AppInstall-Package")
+            self.entries.setdefault(pkg, []).append((f, entry))
+        progress.end()
+
+    def send_extra_info(self, db=None, **kw):
+        """
+        Receive extra parameters from the indexer.
+
+        This may be called more than once, but after init().
+
+        We are using this to get the database instance
+        """
+        if db is not None:
+            for i in self.indexers:
+                i.indexer.set_flags(xapian.TermGenerator.FLAG_SPELLING)
+                i.indexer.set_database(db)
+
+    def doc(self):
+        """
+        Return documentation information for this data source.
+
+        The documentation information is a dictionary with these keys:
+          name: the name for this data source
+          shortDesc: a short description
+          fullDoc: the full description as a chapter in ReST format
+        """
+        return dict(
+            name = "app-install information",
+            shortDesc = "terms, categories and popcon values extracted from the app-install .desktop files",
+            fullDoc = """
+            The AppInstall data source reads .desktop files from %s
+            and adds the following terms:
+
+             * keywords from the .desktop descriptions, via Xapian's
+               TermGenerator, in all requested locales;
+             * .desktop categories, with prefix XDT;
+             * name of .desktop file, with prefix XDF;
+             * a single term "XD", marking that the package contains .desktop
+               files.
+
+            It also adds an "app-popcon" value with popcon ranks from the
+            app-install .desktop files.
+            """ % APPINSTALLDIR
+        )
+
+    def index(self, document, pkg):
+        """
+        Update the document with the information from this data source.
+
+        document  is the document to update
+        pkg       is the python-apt Package object for this package
+        """
+        name = document.get_data()
+        for e in self.entries.get(name, []):
+            fname, entry = e
+            for i in self.indexers:
+                i.index(document, fname, entry)
+
+    def indexDeb822(self, document, pkg):
+        """
+        Update the document with the information from this data source.
+
+        This is alternative to index, and it is used when indexing with package
+        data taken from a custom Packages file.
+
+        document  is the document to update
+        pkg       is the Deb822 object for this package
+        """
+        name = document.get_data()
+        for e in self.entries.get(name, []):
+            fname, entry = e
+            for i in self.indexers:
+                i.index(document, fname, entry)
+
+def init(langs=None, progress=None, **kw):
+    """
+    Create and return the plugin object.
+    """
+    # If we don't have python-xdg, skip it
+    if not HAS_XDG: return None
+    # If we don't have app-install data, skip it
+    if not os.path.isdir(APPINSTALLDIR): return None
+    return AppInstall(langs=langs, progress=progress)

=== modified file 'plugins/apttags.py'
--- plugins/apttags.py	2010-03-01 11:56:55 +0000
+++ plugins/apttags.py	2010-05-16 09:33:58 +0000
@@ -126,7 +126,7 @@
             return
 
 
-def init():
+def init(**kw):
     """
     Create and return the plugin object.
     """

=== modified file 'plugins/debtags.py'
--- plugins/debtags.py	2010-03-19 21:00:08 +0000
+++ plugins/debtags.py	2010-05-16 09:33:58 +0000
@@ -1,7 +1,10 @@
 # Add debtags tags to the index
 
 import re, os, os.path
-from debian import debtags
+try:
+    from debian import debtags
+except ImportError:
+    from debian_bundle import debtags
 
 DEBTAGSDB = "/var/lib/debtags/package-tags"
 
@@ -105,7 +108,7 @@
         for tag in self.db.tags_of_package(pkg["Package"]):
             document.add_term("XT"+tag)
 
-def init():
+def init(**kw):
     """
     Create and return the plugin object.
     """

=== modified file 'plugins/descriptions.py'
--- plugins/descriptions.py	2010-04-09 23:19:15 +0000
+++ plugins/descriptions.py	2010-05-16 09:33:58 +0000
@@ -23,8 +23,8 @@
         the timestamp shows that this plugin is currently not needed, then the
         long initialisation can just be skipped.
         """
-        file = apt_pkg.config.find_file("Dir::Cache::pkgcache")
-        return dict(timestamp = os.path.getmtime(file))
+        fname = apt_pkg.config.find_file("Dir::Cache::pkgcache")
+        return dict(timestamp = os.path.getmtime(fname))
 
     def init(self, info, progress):
         """
@@ -105,8 +105,9 @@
         self.indexer.index_text_without_positions(pkg["Package"])
         self.indexer.index_text_without_positions(pkg["Description"])
 
-def init():
+def init(**kw):
     """
     Create and return the plugin object.
     """
+    apt_pkg.init_config()
     return Descriptions()

=== modified file 'plugins/sections.py'
--- plugins/sections.py	2010-03-01 11:56:55 +0000
+++ plugins/sections.py	2010-05-16 09:33:58 +0000
@@ -80,7 +80,7 @@
         if sec:
             document.add_term("XS"+sec)
 
-def init():
+def init(**kw):
     """
     Create and return the plugin object.
     """

=== modified file 'plugins/template.py'
--- plugins/template.py	2008-02-19 11:19:08 +0000
+++ plugins/template.py	2010-05-16 09:33:58 +0000
@@ -76,10 +76,15 @@
 
 
 
-def init():
+def init(**kw):
     """
     Create and return the plugin object.
 
+    Keyword arguments can hold various kind of information passed by the
+    indexer. Currently documented is:
+
+     - langs: sequence of languages for which we are building the index
+
     Return None here to disable this plugin.
     """
     return Template()

=== modified file 'plugins/translated-desc.py'
--- plugins/translated-desc.py	2010-03-19 21:00:08 +0000
+++ plugins/translated-desc.py	2010-05-16 09:33:58 +0000
@@ -2,17 +2,21 @@
 import xapian
 import re
 import os, os.path, urllib
-from debian import deb822
+try:
+    from debian import deb822
+except ImportError:
+    from debian_bundle import deb822
 
 APTLISTDIR="/var/lib/apt/lists"
 
-def translationFiles():
+def translationFiles(langs=None):
     # Look for files like: ftp.uk.debian.org_debian_dists_sid_main_i18n_Translation-it
     # And extract the language code at the end
     tfile = re.compile(r"_i18n_Translation-([^-]+)$")
     for f in os.listdir(APTLISTDIR):
         mo = tfile.search(f)
         if not mo: continue
+        if langs and not mo.group(1) in langs: continue
         yield urllib.unquote(mo.group(1)), os.path.join(APTLISTDIR, f)
 
 class Indexer:
@@ -44,6 +48,9 @@
         self.indexer.index_text_without_positions(self.descs.get(name, ""))
 
 class TranslatedDescriptions:
+    def __init__(self, langs):
+        self.langs = langs
+
     def info(self):
         """
         Return general information about the plugin.
@@ -62,7 +69,7 @@
         the timestamp shows that this plugin is currently not needed, then the
         long initialisation can just be skipped.
         """
-        maxts = max([0] + [os.path.getmtime(f) for l, f in translationFiles()])
+        maxts = max([0] + [os.path.getmtime(f) for l, f in translationFiles(self.langs)])
         return dict(timestamp = maxts)
 
     def init(self, info, progress):
@@ -78,7 +85,7 @@
         """
 
         self.indexers = []
-        for lang, file in translationFiles():
+        for lang, file in translationFiles(self.langs):
             progress.begin("Reading %s translations from %s" % (lang, file))
             self.indexers.append(Indexer(lang, file))
             progress.end()
@@ -128,11 +135,12 @@
         for i in self.indexers:
             i.index(document)
 
-def init():
+def init(langs=None, **kw):
     """
     Create and return the plugin object.
     """
-    files = [f for l, f in translationFiles()]
+    if not langs: return None
+    files = [f for l, f in translationFiles(langs)]
     if len(files) == 0:
         return None
-    return TranslatedDescriptions()
+    return TranslatedDescriptions(langs=langs)

=== added file 'runtests'
--- runtests	1970-01-01 00:00:00 +0000
+++ runtests	2010-05-16 09:33:58 +0000
@@ -0,0 +1,20 @@
+#!/bin/sh
+export AXI_PLUGIN_DIR=`pwd`/plugins
+export AXI_VALUES_CONF=`pwd`/xapian-index-values.conf
+export AXI_DB_PATH=`pwd`/testdb
+export PYTHONPATH="$PYTHONPATH:`pwd`"
+
+case "$1" in
+	--cov)
+		echo "Run with code coverage..."
+		shift
+		nosetests -w test --with-coverage --cover-package axi --cover-html --cover-html-dir=test-coverage "$@"
+		echo "Coverage information found at file://`pwd`/test/test-coverage"
+		;;
+	--clean)
+		rm -rf test/test-coverage test/.coverage testdb
+		;;
+	*)
+		nosetests -w test "$@"
+		;;
+esac

=== added file 'setup.py'
--- setup.py	1970-01-01 00:00:00 +0000
+++ setup.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,26 @@
+#!/usr/bin/env python
+
+import sys
+import os.path
+from distutils.core import setup
+
+for line in open(os.path.join(os.path.dirname(sys.argv[0]),'update-apt-xapian-index')):
+    if line.startswith('VERSION='):
+        version = eval(line.split('=')[-1])
+
+setup(name='apt-xapian-index',
+      version=version,
+      description='Xapian index of Debian packages',
+#      long_description=''
+      author=['Enrico Zini'],
+      author_email=['enrico@debian.org'],
+      url='http://www.enricozini.org/sw/apt-xapian-index/',
+      install_requires = [
+          "debian", "apt", "xapian",
+      ],
+      license='GPL',
+      platforms='any',
+      packages=['axi'],
+#     py_modules=[''],
+      scripts=['update-apt-xapian-index', 'axi-cache'],
+     )

=== added directory 'test'
=== added file 'test/test_indexer.py'
--- test/test_indexer.py	1970-01-01 00:00:00 +0000
+++ test/test_indexer.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,306 @@
+# -*- coding: utf-8 -*-
+import unittest
+import sys, os.path
+import axi
+import axi.indexer
+import shutil
+import subprocess
+import tools
+
+def smallcache(pkglist=["apt", "debtags", "gedit"]):
+    class sc(object):
+        def __init__(self, cache):
+            self._pkgs = pkglist
+            self._cache = cache
+
+        def has_key(self, name):
+            return name in self._pkgs
+
+        def __len__(self):
+            return len(self._pkgs)
+
+        def __iter__(self):
+            for p in self._pkgs:
+                yield self._cache[p]
+
+        def __getitem__(self, name):
+            if name not in self._pkgs:
+                raise KeyError, "`%s' not in wrapped cache" % name
+            return self._cache[name]
+
+    return sc
+
+class TestIndexer(tools.AxiTestBase):
+    def setUp(self):
+        # Remove the text index if it exists
+        if os.path.exists(axi.XAPIANDBPATH): shutil.rmtree(axi.XAPIANDBPATH)
+        # Prepare a quiet indexer
+        progress = axi.indexer.SilentProgress()
+        self.indexer = axi.indexer.Indexer(progress, True)
+
+    def tearDown(self):
+        # Explicitly set indexer to none, otherwise in the next setUp we rmtree
+        # testdb before the indexer had a chance to delete its lock
+        self.indexer = None
+
+    def testAptRebuild(self):
+        self.indexer._test_wrap_apt_cache(smallcache())
+
+        # No other indexers are running, ensure lock succeeds
+        self.assert_(self.indexer.lock())
+
+        # No index exists, so the indexer should decide it needs to run
+        self.assert_(self.indexer.setupIndexing())
+
+        # Perform a rebuild
+        self.indexer.rebuild()
+
+        # Close the indexer
+        self.indexer = None
+
+        # Ensure that we have an index
+        self.assertCleanIndex()
+
+    def testDeb822Rebuild(self):
+        pkgfile = os.path.join(axi.XAPIANDBPATH, "packages")
+        subprocess.check_call("apt-cache show apt debtags gedit > " + pkgfile, shell=True)
+
+        # No other indexers are running, ensure lock succeeds
+        self.assert_(self.indexer.lock())
+
+        # No index exists, so the indexer should decide it needs to run
+        self.assert_(self.indexer.setupIndexing())
+
+        # Perform a rebuild
+        self.indexer.rebuild(pkgfile)
+
+        # Close the indexer
+        self.indexer = None
+
+        # Ensure that we have an index
+        self.assertCleanIndex()
+
+    def testIncrementalRebuild(self):
+        # Perform the initial indexing
+        progress = axi.indexer.SilentProgress()
+        pre_indexer = axi.indexer.Indexer(progress, True)
+        pre_indexer._test_wrap_apt_cache(smallcache(["apt", "debtags", "gedit"]))
+        self.assert_(pre_indexer.lock())
+        self.assert_(pre_indexer.setupIndexing())
+        pre_indexer.rebuild()
+        pre_indexer = None
+        curidx = open(axi.XAPIANINDEX).read()
+
+        # Ensure that we have an index
+        self.assertCleanIndex()
+
+        # Prepare an incremental update
+        self.indexer._test_wrap_apt_cache(smallcache(["apt", "coreutils", "gedit"]))
+
+        # No other indexers are running, ensure lock succeeds
+        self.assert_(self.indexer.lock())
+
+        # An index exists the plugin modification timestamps are the same, so
+        # we need to force the indexer to run
+        self.assert_(not self.indexer.setupIndexing())
+        self.assert_(self.indexer.setupIndexing(force=True))
+
+        # Perform a rebuild
+        self.indexer.incrementalUpdate()
+
+        # Close the indexer
+        self.indexer = None
+
+        # Ensure that we have an index
+        self.assertCleanIndex()
+
+        # Ensure that we did not create a new index
+        self.assertEqual(open(axi.XAPIANINDEX).read(), curidx)
+
+    def testIncrementalRebuildFromEmpty(self):
+        # Prepare an incremental update
+        self.indexer._test_wrap_apt_cache(smallcache())
+
+        # No other indexers are running, ensure lock succeeds
+        self.assert_(self.indexer.lock())
+
+        # No index exists, so the indexer should decide it needs to run
+        self.assert_(self.indexer.setupIndexing())
+
+        # Perform an incremental rebuild, which should fall back on a normal
+        # one
+        self.indexer.incrementalUpdate()
+
+        # Close the indexer
+        self.indexer = None
+
+        # Ensure that we have an index
+        self.assertCleanIndex()
+
+#    def test_url(self):
+#        """ Environ: URL building """
+#        request.bind({'HTTP_HOST':'example.com'}, None)
+#        self.assertEqual('http://example.com/', request.url)
+#        request.bind({'SERVER_NAME':'example.com'}, None)
+#        self.assertEqual('http://example.com/', request.url)
+#        request.bind({'SERVER_NAME':'example.com', 'SERVER_PORT':'81'}, None)
+#        self.assertEqual('http://example.com:81/', request.url)
+#        request.bind({'wsgi.url_scheme':'https', 'SERVER_NAME':'example.com'}, None)
+#        self.assertEqual('https://example.com:80/', request.url)
+#        request.bind({'HTTP_HOST':'example.com', 'PATH_INFO':'/path', 'QUERY_STRING':'1=b&c=d', 'SCRIPT_NAME':'/sp'}, None)
+#        self.assertEqual('http://example.com/sp/path?1=b&c=d', request.url)
+#
+#    def test_dict_access(self):
+#        """ Environ: request objects are environment dicts """
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        request.bind(e, None)
+#        for k, v in e.iteritems():
+#            self.assertTrue(k in request)
+#            self.assertTrue(request[k] == v)
+#
+#    def test_header_access(self):
+#        """ Environ: Request objects decode headers """
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['HTTP_SOME_HEADER'] = 'some value'
+#        request.bind(e, None)
+#        request['HTTP_SOME_OTHER_HEADER'] = 'some other value'
+#        self.assertTrue('Some-Header' in request.header)
+#        self.assertTrue(request.header['Some-Header'] == 'some value')
+#        self.assertTrue(request.header['Some-Other-Header'] == 'some other value')
+#
+#
+#    def test_cookie(self):
+#        """ Environ: COOKIES """ 
+#        t = dict()
+#        t['a=a'] = {'a': 'a'}
+#        t['a=a; b=b'] = {'a': 'a', 'b':'b'}
+#        t['a=a; a=b'] = {'a': 'b'}
+#        for k, v in t.iteritems():
+#            request.bind({'HTTP_COOKIE': k}, None)
+#            self.assertEqual(v, request.COOKIES)
+#
+#    def test_get(self):
+#        """ Environ: GET data """ 
+#        e = {}
+#        e['QUERY_STRING'] = 'a=a&a=1&b=b&c=c'
+#        request.bind(e, None)
+#        self.assertTrue('a' in request.GET)
+#        self.assertTrue('b' in request.GET)
+#        self.assertEqual(['a','1'], request.GET.getall('a'))
+#        self.assertEqual(['b'], request.GET.getall('b'))
+#        self.assertEqual('1', request.GET['a'])
+#        self.assertEqual('b', request.GET['b'])
+#        
+#    def test_post(self):
+#        """ Environ: POST data """ 
+#        sq = u'a=a&a=1&b=b&c=c'.encode('utf8')
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['wsgi.input'].write(sq)
+#        e['wsgi.input'].seek(0)
+#        e['CONTENT_LENGTH'] = str(len(sq))
+#        e['REQUEST_METHOD'] = "POST"
+#        request.bind(e, None)
+#        self.assertTrue('a' in request.POST)
+#        self.assertTrue('b' in request.POST)
+#        self.assertEqual(['a','1'], request.POST.getall('a'))
+#        self.assertEqual(['b'], request.POST.getall('b'))
+#        self.assertEqual('1', request.POST['a'])
+#        self.assertEqual('b', request.POST['b'])
+#
+#    def test_params(self):
+#        """ Environ: GET and POST are combined in request.param """ 
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['wsgi.input'].write(tob('b=b&c=p'))
+#        e['wsgi.input'].seek(0)
+#        e['CONTENT_LENGTH'] = '7'
+#        e['QUERY_STRING'] = 'a=a&c=g'
+#        e['REQUEST_METHOD'] = "POST"
+#        request.bind(e, None)
+#        self.assertEqual(['a','b','c'], sorted(request.params.keys()))
+#        self.assertEqual('p', request.params['c'])
+#
+#    def test_getpostleak(self):
+#        """ Environ: GET and POST sh0uld not leak into each other """ 
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['wsgi.input'].write(u'b=b'.encode('utf8'))
+#        e['wsgi.input'].seek(0)
+#        e['CONTENT_LENGTH'] = '3'
+#        e['QUERY_STRING'] = 'a=a'
+#        e['REQUEST_METHOD'] = "POST"
+#        request.bind(e, None)
+#        self.assertEqual(['a'], request.GET.keys())
+#        self.assertEqual(['b'], request.POST.keys())
+#
+#    def test_body(self):
+#        """ Environ: Request.body should behave like a file object factory """ 
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['wsgi.input'].write(u'abc'.encode('utf8'))
+#        e['wsgi.input'].seek(0)
+#        e['CONTENT_LENGTH'] = str(3)
+#        request.bind(e, None)
+#        self.assertEqual(u'abc'.encode('utf8'), request.body.read())
+#        self.assertEqual(u'abc'.encode('utf8'), request.body.read(3))
+#        self.assertEqual(u'abc'.encode('utf8'), request.body.readline())
+#        self.assertEqual(u'abc'.encode('utf8'), request.body.readline(3))
+#
+#    def test_bigbody(self):
+#        """ Environ: Request.body should handle big uploads using files """
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['wsgi.input'].write((u'x'*1024*1000).encode('utf8'))
+#        e['wsgi.input'].seek(0)
+#        e['CONTENT_LENGTH'] = str(1024*1000)
+#        request.bind(e, None)
+#        self.assertTrue(hasattr(request.body, 'fileno'))        
+#        self.assertEqual(1024*1000, len(request.body.read()))
+#        self.assertEqual(1024, len(request.body.read(1024)))
+#        self.assertEqual(1024*1000, len(request.body.readline()))
+#        self.assertEqual(1024, len(request.body.readline(1024)))
+#
+#    def test_tobigbody(self):
+#        """ Environ: Request.body should truncate to Content-Length bytes """
+#        e = {}
+#        wsgiref.util.setup_testing_defaults(e)
+#        e['wsgi.input'].write((u'x'*1024).encode('utf8'))
+#        e['wsgi.input'].seek(0)
+#        e['CONTENT_LENGTH'] = '42'
+#        request.bind(e, None)
+#        self.assertEqual(42, len(request.body.read()))
+#        self.assertEqual(42, len(request.body.read(1024)))
+#        self.assertEqual(42, len(request.body.readline()))
+#        self.assertEqual(42, len(request.body.readline(1024)))
+#
+#class TestMultipart(unittest.TestCase):
+#    def test_multipart(self):
+#        """ Environ: POST (multipart files and multible values per key) """
+#        fields = [('field1','value1'), ('field2','value2'), ('field2','value3')]
+#        files = [('file1','filename1.txt','content1'), ('file2','filename2.py',u'äöü')]
+#        e = tools.multipart_environ(fields=fields, files=files)
+#        request.bind(e, None)
+#        # File content
+#        self.assertTrue('file1' in request.POST)
+#        self.assertEqual('content1', request.POST['file1'].file.read())
+#        # File name and meta data
+#        self.assertTrue('file2' in request.POST)
+#        self.assertEqual('filename2.py', request.POST['file2'].filename)
+#        # UTF-8 files
+#        x = request.POST['file2'].file.read()
+#        if sys.version_info >= (3,0,0):
+#            x = x.encode('ISO-8859-1')
+#        self.assertEqual(u'äöü'.encode('utf8'), x)
+#        # No file
+#        self.assertTrue('file3' not in request.POST)
+#        # Field (single)
+#        self.assertEqual('value1', request.POST['field1'])
+#        # Field (multi)
+#        self.assertEqual(2, len(request.POST.getall('field2')))
+#        self.assertEqual(['value2', 'value3'], request.POST.getall('field2'))
+
+if __name__ == '__main__':
+    unittest.main()

=== added file 'test/tools.py'
--- test/tools.py	1970-01-01 00:00:00 +0000
+++ test/tools.py	2010-05-16 09:33:58 +0000
@@ -0,0 +1,21 @@
+# -*- coding: utf-8 -*-
+import unittest
+import axi
+import axi.indexer
+import os.path
+
+class AxiTestBase(unittest.TestCase):
+    def assertCleanIndex(self):
+        self.assert_(os.path.exists(axi.XAPIANINDEX))
+        self.assert_(os.path.exists(axi.XAPIANDBSTAMP))
+        self.assert_(os.path.exists(axi.XAPIANDBVALUES))
+        self.assert_(os.path.exists(axi.XAPIANDBDOC))
+        self.assert_(not os.path.exists(axi.XAPIANDBUPDATESOCK))
+
+        # Index is clean and up to date: an indexer should tell us that it does
+        # not need to run
+        progress = axi.indexer.SilentProgress()
+        indexer = axi.indexer.Indexer(progress, True)
+        self.assert_(indexer.lock())
+        self.assert_(not indexer.setupIndexing())
+        indexer = None

=== modified file 'update-apt-xapian-index'
--- update-apt-xapian-index	2010-04-11 09:21:41 +0000
+++ update-apt-xapian-index	2010-05-16 09:33:58 +0000
@@ -1,10 +1,11 @@
 #!/usr/bin/python
+# -*- coding: utf-8 -*-
 
 #
 # update-apt-xapian-index - Maintain a system-wide Xapian index of Debian
 #                           package information
 #
-# Copyright (C) 2007  Enrico Zini <enrico@debian.org>
+# Copyright (C) 2007--2010  Enrico Zini <enrico@debian.org>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,540 +22,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import os
-
-# Setup configuration
-PLUGINDIR = os.environ.get("AXI_PLUGIN_DIR", "/usr/share/apt-xapian-index/plugins")
-XAPIANDBPATH = os.environ.get("AXI_DB_PATH", "/var/lib/apt-xapian-index")
-XAPIANDBSTAMP = XAPIANDBPATH + "/update-timestamp"
-XAPIANDBLOCK = XAPIANDBPATH + "/update-lock"
-XAPIANDBUPDATESOCK = XAPIANDBPATH + "/update-socket"
-XAPIANDBVALUES = XAPIANDBPATH + "/values"
-XAPIANDBDOC = XAPIANDBPATH + "/README"
-
-class Progress:
-    def __init__(self):
-        self.task = None
-        self.halfway = False
-        self.is_verbose = False
-    def begin(self, task):
-        self.task = task
-        print "%s..." % self.task,
-        sys.stdout.flush()
-        self.halfway = True
-    def progress(self, percent):
-        print "\r%s... %d%%" % (self.task, percent),
-        sys.stdout.flush()
-        self.halfway = True
-    def end(self):
-        print "\r%s: done.  " % self.task
-        self.halfway = False
-    def verbose(self, *args):
-        if not self.is_verbose: return
-        if self.halfway:
-            print
-        print " ".join(args)
-        self.halfway = False
-    def notice(self, *args):
-        if self.halfway:
-            print
-        print >>sys.stderr, " ".join(args)
-        self.halfway = False
-    def warning(self, *args):
-        if self.halfway:
-            print
-        print >>sys.stderr, " ".join(args)
-        self.halfway = False
-    def error(self, *args):
-        if self.halfway:
-            print
-        print >>sys.stderr, " ".join(args)
-        self.halfway = False
-
-class BatchProgress:
-    def __init__(self):
-        self.task = None
-    def begin(self, task):
-        self.task = task
-        print "begin: %s\n" % self.task,
-        sys.stdout.flush()
-    def progress(self, percent):
-        print "progress: %d/100\n" % percent,
-        sys.stdout.flush()
-    def end(self):
-        print "done: %s\n" % self.task
-        sys.stdout.flush()
-    def verbose(self, *args):
-        print "verbose: %s" % (" ".join(args))
-        sys.stdout.flush()
-    def notice(self, *args):
-        print "notice: %s" % (" ".join(args))
-        sys.stdout.flush()
-    def warning(self, *args):
-        print "warning: %s" % (" ".join(args))
-        sys.stdout.flush()
-    def error(self, *args):
-        print "error: %s" % (" ".join(args))
-        sys.stdout.flush()
-
-class SilentProgress:
-    def begin(self, task):
-        pass
-    def progress(self, percent):
-        pass
-    def end(self):
-        pass
-    def verbose(self, *args):
-        pass
-    def notice(self, *args):
-        pass
-    def warning(self, *args):
-        print >>sys.stderr, " ".join(args)
-    def error(self, *args):
-        print >>sys.stderr, " ".join(args)
-
-class ClientProgress:
-    def __init__(self, progress):
-        self.sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
-        self.sock.settimeout(None)
-        self.sock.connect(XAPIANDBUPDATESOCK)
-        self.progress = progress
-
-    def loop(self):
-        hasBegun = False
-        while True:
-            msg = self.sock.recv(4096)
-            try:
-                args = pickle.loads(msg)
-            except EOFError:
-                progress.error("The other update has stopped")
-                return
-            action = args[0]
-            args = args[1:]
-            if action == "begin":
-                progress.begin(*args)
-                hasBegun = True
-            elif action == "progress":
-                if not hasBegun:
-                    progress.begin(args[0])
-                    hasBegun = True
-                progress.progress(*args[1:])
-            elif action == "end":
-                if not hasBegun:
-                    progress.begin(args[0])
-                    hasBegun = True
-                progress.end(*args[1:])
-            elif action == "verbose":
-                progress.verbose(*args)
-            elif action == "notice":
-                progress.notice(*args)
-            elif action == "error":
-                progress.error(*args)
-            elif action == "alldone":
-                break
-            else:
-                progress.error("unknown action '%s' from other update-apt-xapian-index.  Arguments: '%s'" % (action, ", ".join(map(repr, args))))
-
-
-class ServerSenderProgress:
-    def __init__(self, sock, task = None):
-        self.sock = sock
-        self.task = task
-    def __del__(self):
-        self._send(pickle.dumps(("alldone",)))
-    def _send(self, text):
-        try:
-            self.sock.send(text)
-        except:
-            pass
-    def begin(self, task):
-        self.task = task
-        self._send(pickle.dumps(("begin", self.task)))
-    def progress(self, percent):
-        self._send(pickle.dumps(("progress", self.task, percent)))
-    def end(self):
-        self._send(pickle.dumps(("end", self.task)))
-    def verbose(self, *args):
-        self._send(pickle.dumps(("verbose",) + args))
-    def notice(self, *args):
-        self._send(pickle.dumps(("notice",) + args))
-    def warning(self, *args):
-        self._send(pickle.dumps(("warning",) + args))
-    def error(self, *args):
-        self._send(pickle.dumps(("error",) + args))
-
-class ServerProgress:
-    def __init__(self, mine):
-        self.task = None
-        self.proxied = [mine]
-        self.sockfile = XAPIANDBUPDATESOCK
-        try:
-            os.unlink(self.sockfile)
-        except OSError:
-            pass
-        self.sock = socket.socket(socket.AF_UNIX, socket.SOCK_STREAM)
-        self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
-        self.sock.bind(XAPIANDBUPDATESOCK)
-        self.sock.setblocking(False)
-        self.sock.listen(5)
-        # Disallowing unwanted people to mess with the file is automatic, as
-        # the socket has the ownership of the user we're using, and people
-        # can't connect to it unless they can write to it
-    def __del__(self):
-        self.sock.close()
-        os.unlink(self.sockfile)
-    def _check(self):
-        try:
-            sock = self.sock.accept()[0]
-            self.proxied.append(ServerSenderProgress(sock, self.task))
-        except socket.error, e:
-            if e.args[0] != errno.EAGAIN:
-                raise
-        pass
-    def begin(self, task):
-        self._check()
-        self.task = task
-        for x in self.proxied: x.begin(task)
-    def progress(self, percent):
-        self._check()
-        for x in self.proxied: x.progress(percent)
-    def end(self):
-        self._check()
-        for x in self.proxied: x.end()
-    def verbose(self, *args):
-        self._check()
-        for x in self.proxied: x.verbose(*args)
-    def notice(self, *args):
-        self._check()
-        for x in self.proxied: x.notice(*args)
-    def warning(self, *args):
-        self._check()
-        for x in self.proxied: x.warning(*args)
-    def error(self, *args):
-        self._check()
-        for x in self.proxied: x.error(*args)
-
-
-class Addon:
-    def __init__(self, file):
-        self.name = os.path.basename(file)
-        self.name = os.path.splitext(self.name)[0]
-        self.filename = os.path.basename(file)
-        self.module = imp.load_source(self.name, file)
-        self.obj = self.module.init()
-        if self.obj:
-            self.info = self.obj.info()
-
-    def send_extra_info(self, **kw):
-        func = getattr(self.obj, "send_extra_info", None)
-        if func is not None:
-            func(**kw)
-
-class ExecutionTime(object):
-    """
-    Helper that can be used in with statements to have a simple
-    measure of the timming of a particular block of code, e.g.
-    with ExecutinTime("db flush"):
-        db.flush()
-    """
-    import time
-    def __init__(self, info=""):
-        self.info = info
-    def __enter__(self):
-        self.now = time.time()
-    def __exit__(self, type, value, stack):
-        print "%s: %s" % (self.info, time.time() - self.now)
-
-
-#
-# Function definitions
-#
-
-def readPlugins(plugindir, progress):
-    """
-    Read the addons, in sorted order
-    """
-    addons = []
-    for file in sorted(glob.glob(PLUGINDIR+"/*.py")):
-        progress.verbose("Reading plugin %s." % file)
-        # Skip non-files and hidden files
-        if not os.path.isfile(file) or file[0] == '.':
-            continue;
-        addon = Addon(file)
-        if addon.obj != None:
-            addons.append(addon)
-    return addons
-
-def get_document(pkg, addons):
-    """
-    Get a xapian.Document for the given pkg and with given
-    addons
-    """
-    document = xapian.Document()
-    # The document data is the package name
-    document.set_data(pkg.name)
-    # add information about the version of the package in slot 0
-    document.add_value(0, pkg.candidate.version)
-    # Index the package name with a special prefix, to be able to find this
-    # document by exact package name match
-    document.add_term("XP"+pkg.name)
-    # Have all the various plugins index their things
-    for addon in addons:
-        addon.obj.index(document, pkg)
-    return document
-
-def compareCacheToDb(cache, db, progress):
-    """
-    Compare the apt cache to the database and return dicts
-    of the form (pkgname, docid) for the following states:
-
-    unchanged - no new version since the last update
-    outdated - a new version since the last update
-    obsolete - no longer in the apt cache
-    """
-    unchanged = {}
-    outdated = {}
-    obsolete = {}
-    progress.begin("Reading Xapian index")
-    count = db.get_doccount()
-    for (idx, m) in enumerate(db.postlist("")):
-        if idx % 5000 == 0: progress.progress(100*idx/count)
-        doc = db.get_document(m.docid)
-        pkg = doc.get_data()
-        # this will return '' if there is no value 0, which is fine because it
-        # will fail the comparison with the candidate version causing a reindex
-        dbver = doc.get_value(0)
-        # check if the package no longer exists
-        if not cache.has_key(pkg) or not cache[pkg].candidate:
-            obsolete[pkg] = m.docid
-        # check if we have a new version, we do not have to delete
-        # the record, 
-        elif cache[pkg].candidate.version != dbver:
-            outdated[pkg] = m.docid
-        # its a valid package and we know about it already
-        else:
-            unchanged[pkg] = m.docid
-    progress.end()
-    return unchanged, outdated, obsolete
-
-def updateIndex(pathname, addons, progress):
-    """
-    Update the index
-    """
-    db = xapian.WritableDatabase(pathname, xapian.DB_CREATE_OR_OPEN)
-    cache = apt.Cache(memonly=True,progress=aptprogress)
-    count = len(cache)
-
-    unchanged, outdated, obsolete = compareCacheToDb(cache, db, progress)
-    progress.verbose("Unchanged versions: %s, oudated version: %s, "
-                     "obsolete versions: %s" % (len(unchanged),
-                                                len(outdated),
-                                                len(obsolete)))
-
-    progress.begin("Update Xapian index")
-    for a in addons: a.send_extra_info(db=db, aptcache=cache)
-    for idx, pkg in enumerate(cache):
-        if idx % 1000 == 0: progress.progress(100*idx/count)
-        if not pkg.candidate:
-            continue
-        if pkg.name in unchanged:
-            continue
-        elif pkg.name in outdated:
-            # update the existing
-            db.replace_document(outdated[pkg.name],
-                                get_document(pkg, addons))
-        else:
-            # add the new ones
-            db.add_document(get_document(pkg, addons))
-
-    # and remove the obsoletes
-    for docid in obsolete.values():
-        db.delete_document(docid)
-
-    # finished
-    db.flush()
-    progress.end()
-    return True
-
-def buildIndex(pathname, addons, progress):
-    """
-    Create a new Xapian index with the content provided by the addons
-    """
-    progress.begin("Rebuilding Xapian index")
-
-    # Create a new Xapian index
-    db = xapian.WritableDatabase(pathname, xapian.DB_CREATE_OR_OVERWRITE)
-    # It seems to be faster without transactions, at the moment
-    #db.begin_transaction(False)
-
-    # Iterate all Debian packages
-
-    # force apt to not write a pkgcache.bin
-    cache = apt.Cache(memonly=True,progress=aptprogress)
-    count = len(cache)
-    for a in addons: a.send_extra_info(db=db, aptcache=cache)
-    for idx, pkg in enumerate(cache):
-        if not pkg.candidate:
-            continue
-        # Print progress
-        if idx % 200 == 0: progress.progress(100*idx/count)
-        # Add the document to the index
-        db.add_document(get_document(pkg, addons))
-    #db.commit_transaction();
-    db.flush()
-    progress.end()
-
-def buildIndexDeb822(pathname, records, addons, progress):
-    """
-    Create a new Xapian index with the content provided by the addons
-    """
-    progress.begin("Rebuilding Xapian index")
-
-    # Create a new Xapian index
-    db = xapian.WritableDatabase(pathname, xapian.DB_CREATE_OR_OVERWRITE)
-    # It seems to be faster without transactions, at the moment
-    #db.begin_transaction(False)
-
-    # Iterate all Debian packages
-
-    # force apt to not write a pkgcache.bin
-    cache = apt.Cache(memonly=True,progress=aptprogress)
-    count = len(cache)
-    for a in addons: a.send_extra_info(db=db, aptcache=cache)
-    for idx, pkg in enumerate(records):
-        # Print progress
-        if idx % 200 == 0: progress.progress(100*idx/count)
-
-        document = xapian.Document()
-
-        # The document data is the package name
-        document.set_data(pkg["Package"])
-
-        # Index the package name with a special prefix, to be able to find this
-        # document by exact package name match
-        document.add_term("XP"+pkg["Package"])
-
-        # Have all the various plugins index their things
-        for addon in addons:
-            addon.obj.indexDeb822(document, pkg)
-
-        # Add the document to the index
-        db.add_document(document)
-    #db.commit_transaction();
-    db.flush()
-    progress.end()
-
-
-def writeValues(pathname, values, values_desc, progress):
-    """
-    Write the value information on the given file
-    """
-    progress.verbose("Writing value information to %s." % pathname)
-    out = open(pathname+".tmp", "w")
-
-    print >>out, textwrap.dedent("""
-    # This file contains the mapping between names of numeric values indexed in the
-    # APT Xapian index and their index
-    #
-    # Xapian allows to index numeric values as well as keywords and to use them for
-    # all sorts of useful querying tricks.  However, every numeric value needs to
-    # have a unique index, and this configuration file is needed to record which
-    # indices are allocated and to provide a mnemonic name for them.
-    #
-    # The format is exactly like /etc/services with name, number and optional
-    # aliases, with the difference that the second column does not use the
-    # "/protocol" part, which would be meaningless here.
-    """).lstrip()
-
-    for name, idx in sorted(values.iteritems(), key=lambda x: x[1]):
-        desc = values_desc[name]
-        print >>out, "%s\t%d\t# %s" % (name, idx, desc)
-
-    out.close()
-    # Atomic update of the documentation
-    os.rename(pathname+".tmp", pathname)
-
-def writeDoc(pathname, addons, progress):
-    """
-    Write the documentation in the given file
-    """
-    progress.verbose("Writing documentation to %s." % pathname)
-    # Collect the documentation
-    docinfo = []
-    for addon in addons:
-        try:
-            doc = addon.obj.doc()
-            if doc != None:
-                docinfo.append(dict(
-                    name = doc['name'],
-                    shortDesc = doc['shortDesc'],
-                    fullDoc = doc['fullDoc']))
-        except:
-            # If a plugin has problem returning documentation, don't worry about it
-            progress.notice("Skipping documentation for plugin", addon.filename)
-
-    # Write the documentation in pathname
-    out = open(pathname+".tmp", "w")
-    print >>out, textwrap.dedent("""
-    ===============
-    Database layout
-    ===============
-
-    This Xapian database indexes Debian package information.  To query the
-    database, open it as ``%s/index``.
-
-    Data are indexed either as terms or as values.  Words found in package
-    descriptions are indexed lowercase, and all other kinds of terms have an
-    uppercase prefix as documented below.
-
-    Numbers are indexed as Xapian numeric values.  A list of the meaning of the
-    numeric values is found in ``%s``.
-
-    The data sources used for indexing are:
-    """).lstrip() % (XAPIANDBPATH, XAPIANDBVALUES)
-
-    for d in docinfo:
-        print >>out, " * %s: %s" % (d['name'], d['shortDesc'])
-
-    print >>out, textwrap.dedent("""
-    This Xapian index follows the conventions for term prefixes described in
-    ``/usr/share/doc/xapian-omega/termprefixes.txt.gz``.
-
-    Extra Debian data sources can define more extended prefixes (starting with
-    ``X``): their meaning is documented below together with the rest of the data
-    source documentation.
-
-    At the very least, at least the package name (with the ``XP`` prefix) will
-    be present in every document in the database.  This allows to quickly
-    lookup a Xapian document by package name.
-
-    The user data associated to a Xapian document is the package name.
-
-
-    -------------------
-    Active data sources
-    -------------------
-
-    """)
-    for d in docinfo:
-        print >>out, d['name']
-        print >>out, '='*len(d['name'])
-        print >>out, textwrap.dedent(d['fullDoc'])
-        print >>out
-
-    out.close()
-    # Atomic update of the documentation
-    os.rename(pathname+".tmp", pathname)
-
-
 #
 # Main program body
 #
 
+# Minimal imports so we are always able to print command line help
 from optparse import OptionParser
 import sys
+import warnings
 
-VERSION="0.29"
+VERSION="0.35"
 
 class Parser(OptionParser):
     def __init__(self, *args, **kwargs):
@@ -574,191 +51,56 @@
 parser.add_option("--pkgfile", action="store", help="do not use the APT cache, but the given Package file")
 parser.add_option("--batch-mode", action="store_true", help="use progress reporting suitable from programatic parsing.")
 parser.add_option("-u","--update", action="store_true", help="incremental update, reindexing only those packages whose version has changed since the last run")
-(options, args) = parser.parse_args()
-
-
-# Here starts the main functionality.  Imports things here so we can do --help
-# without requiring lots of dependencies (this helps at least help2man at
-# package build time)
-import warnings
-# Yes, apt, thanks, I know, the api isn't stable, thank you so very much
-#warnings.simplefilter('ignore', FutureWarning)
-warnings.filterwarnings("ignore","apt API not stable yet")
-import apt
-warnings.resetwarnings()
-import os.path, re, imp, glob, xapian, textwrap, shutil, fcntl, errno, itertools, time
-import socket, errno
-import cPickle as pickle
-
-class AptSilentProgress(apt.progress.text.OpProgress) :
-    def __init__(self): 
-        pass
-    def done(self):
-        pass
-    def update(self,percent):
-        pass
-
-#if options.quiet: print "quiet"
-#if options.verbose: print "verbose"
-#if options.force: print "force"
+(opts, args) = parser.parse_args()
+
+
+# Rest of the imports here
+import axi
+import axi.indexer
+
+#if opts.quiet: print "quiet"
+#if opts.verbose: print "verbose"
+#if opts.force: print "force"
 
 # Instantiate the progress report
-if options.batch_mode:
-    aptprogress = None
-    progress = BatchProgress()
-elif options.quiet:
-    aptprogress = AptSilentProgress()
-    progress = SilentProgress()
+if opts.batch_mode:
+    quietapt = False
+    progress = axi.indexer.BatchProgress()
+elif opts.quiet:
+    quietapt = True
+    progress = axi.indexer.SilentProgress()
     warnings.filterwarnings("ignore","")
 else:
-    aptprogress = None
-    progress = Progress()
+    quietapt = False
+    progress = axi.indexer.Progress()
 
-if options.verbose:
+if opts.verbose:
     progress.is_verbose = True
 
-# Create the database directory if missing
-try:
-    # Try to create it anyway
-    os.mkdir(XAPIANDBPATH)
-except OSError, e:
-    if e.errno != errno.EEXIST:
-        # If we got an error besides path already existing, fail
-        raise
-    elif not os.path.isdir(XAPIANDBPATH):
-        # If that path already exists, but is not a directory, also fail
-        raise
+# Create the indexer
+indexer = axi.indexer.Indexer(progress, quietapt)
 
 # Lock the session so that we prevent concurrent updates
-lockfd = os.open(XAPIANDBLOCK, os.O_RDWR | os.O_CREAT)
-lockpyfd = os.fdopen(lockfd)
-try:
-    fcntl.lockf(lockpyfd, fcntl.LOCK_EX | fcntl.LOCK_NB)
-    progress = ServerProgress(progress)
-except IOError, e:
-    if e.errno == errno.EACCES or e.errno == errno.EAGAIN:
-        progress.notice("Another update is already running: showing its progress.")
-        childProgress = ClientProgress(progress)
-        childProgress.loop()
-        sys.exit(0)
-    else:
-        raise
-
-# Read values database
-#values = readValueDB(VALUESCONF, progress)
-
-# Read the addons, in sorted order
-addons = readPlugins(PLUGINDIR, progress)
-
-# Ensure that we have something to do
-if len(addons) == 0:
-    progress.notice("No indexing plugins found in %s" % PLUGINDIR)
-    sys.exit(1)
-
-# Get the most recent modification timestamp of the data sources
-ds_timestamp = max([x.info['timestamp'] for x in addons])
-
-# Get the timestamp of the last database update
-try:
-    if os.path.exists(XAPIANDBSTAMP):
-        cur_timestamp = os.path.getmtime(XAPIANDBSTAMP)
-    else:
-        cur_timestamp = 0
+try:
+    locked = indexer.lock()
 except OSError, e:
-    cur_timestamp = 0
-    progress.notice("Reading current timestamp failed: %s. Assuming the index has not been created yet." % e)
-
-if options.verbose:
-    progress.verbose("Most recent dataset:    %s." % time.ctime(ds_timestamp))
-    progress.verbose("Most recent update for: %s." % time.ctime(cur_timestamp))
-
-# See if we need an update
-if ds_timestamp <= cur_timestamp:
-    if options.force:
-        progress.notice("The index %s is up to date, but rebuilding anyway as requested." % XAPIANDBPATH)
-    else:
-        progress.notice("The index %s is up to date" % XAPIANDBPATH)
-        sys.exit(0)
-
-# Build the value database
-progress.verbose("Aggregating value information.")
-values = dict(version=0)
-values_seq = 1
-values_desc = dict(version="package version")
-for addon in addons:
-    for v in addon.info.get("values", []):
-        values[v['name']] = values_seq
-        values_seq += 1
-        values_desc[v['name']] = v['desc']
-
-# Tell the addons to do the long initialisation bits
-progress.verbose("Initializing plugins.")
-for addon in addons:
-    addon.obj.init(dict(values = values), progress)
-
-# update only mode
-if options.update:
-    index = os.path.join(os.path.abspath(XAPIANDBPATH), "index")
-    if not os.path.exists(index):
-        f=open(index, "w")
-        f.write("auto %s.1" % index)
-        f.close()
-    (dbkind, dbpath) = open(index).readline().split()
-    res = updateIndex(dbpath, addons, progress)
-    if not res:
+    import errno
+    if e.errno == errno.EACCES:
+        print >>sys.stderr, "You probably need to be root to do this."
         sys.exit(1)
-    # touch the index to update the timestamp
-    open(XAPIANDBSTAMP, "w").close()
-    sys.exit()
-
-# Create a new Xapian index with the content provided by the addons
-# Xapian takes care of preventing concurrent updates and removing the old
-# database if it's left over by a previous crashed update
-
-# Create a temporary file name
-for idx in itertools.count(1):
-    tmpidxfname = "index.%d" % idx
-    dbdir = XAPIANDBPATH + "/" + tmpidxfname
-    if not os.path.exists(dbdir): break;
-
-if options.pkgfile:
-    from debian import deb822
-    buildIndexDeb822(dbdir, deb822.Deb822.iter_paragraphs(open(options.pkgfile)), addons, progress)
+    raise
+if not locked:
+    indexer.slave()
+    sys.exit(0)
+
+# Set up the indexer and check that we have something to do
+if not indexer.setupIndexing(force=opts.force):
+    sys.exit(0)
+
+if opts.update:
+    # update only mode
+    indexer.incrementalUpdate()
 else:
-    buildIndex(dbdir, addons, progress)
-
-# Update the 'index' symlink to point at the new index
-progress.verbose("Installing the new index.")
-try:
-    os.unlink(XAPIANDBPATH + "/index.tmp")
-except OSError:
-    # Ignore the error here: we're deleting it 'just in case', because symlink
-    # wouldn't delete it itself
-    pass
-
-#os.symlink(tmpidxfname, XAPIANDBPATH + "/index.tmp")
-out = open(XAPIANDBPATH + "/index.tmp", "w")
-print >>out, "auto", os.path.join(os.path.abspath(XAPIANDBPATH), tmpidxfname)
-out.close()
-os.rename(XAPIANDBPATH + "/index.tmp", XAPIANDBPATH + "/index")
-
-# Remove all other index.* directories that are not the newly created one
-for file in os.listdir(XAPIANDBPATH):
-    if not file.startswith("index."): continue
-    # Only delete directories
-    if not os.path.isdir(XAPIANDBPATH + "/" + file): continue
-    # Don't delete what we just created
-    if file == tmpidxfname: continue
-    fullpath = XAPIANDBPATH + "/" + file
-    progress.verbose("Removing old index %s." % fullpath)
-    shutil.rmtree(fullpath)
-
-# Commit the changes and update the last update timestamp
-if not os.path.exists(XAPIANDBSTAMP):
-    open(XAPIANDBSTAMP, "w").close()
-os.utime(XAPIANDBSTAMP, (ds_timestamp, ds_timestamp))
-
-writeValues(XAPIANDBVALUES, values, values_desc, progress)
-writeDoc(XAPIANDBDOC, addons, progress)
+    indexer.rebuild(opts.pkgfile)
 
 sys.exit(0)

